#!/bin/sh
CURRENT_PATH=`pwd`
SCRIPT_PATH=`dirname $0`
CONTRIB_PATH=$SCRIPT_PATH
FREEHEP_PATH=$SCRIPT_PATH/freehep
FOXTROT_PATH=$SCRIPT_PATH/foxtrot
NETCDF_PATH=$SCRIPT_PATH/netCDF

# function for getting absolute directory
get_absolute_dir() {
    current_dir=`pwd`
    cd "$1"
    absolute_dir=`pwd`
    cd $current_dir
    echo "$absolute_dir"
}

# set absolute directory
SCRIPT_PATH=`get_absolute_dir $SCRIPT_PATH`
CONTRIB_PATH=`get_absolute_dir $CONTRIB_PATH`
FREEHEP_PATH=`get_absolute_dir $FREEHEP_PATH`
FOXTROT_PATH=`get_absolute_dir $FOXTROT_PATH`
NETCDF_PATH=`get_absolute_dir $NETCDF_PATH`

# build scripts
FREEHEP_SCRIPT=$FREEHEP_PATH/build.sh
FOXTROT_SCRIPT=$FOXTROT_PATH/build/build.sh
NETCDF_SCRIPT=$NETCDF_PATH/cdm/build.sh

case "$1" in
rebuild)
  $FREEHEP_SCRIPT rebuild
  $FOXTROT_SCRIPT rebuild
  $NETCDF_SCRIPT rebuild
  ;;
build)
  $FREEHEP_SCRIPT build
  $FOXTROT_SCRIPT build
  $NETCDF_SCRIPT build
  ;;
clean)
  $FREEHEP_SCRIPT clean
  $FOXTROT_SCRIPT clean
  $NETCDF_SCRIPT clean
  ;;
*)
  echo "Usage: ${0##*/}: { build | rebuild | clean }" 2>&1
  exit 65
  ;;
esac

exit 0
