/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGPropertyFileNetCDFDataDialog.java
 *
 * Created on 2009/08/28, 10:25:31
 */

package jp.riken.brain.ni.samuraigraph.application;

import java.util.Map;

import javax.swing.JButton;
import javax.swing.text.JTextComponent;

import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfoSet;
import jp.riken.brain.ni.samuraigraph.data.SGIDataSetupTableHolder;
import jp.riken.brain.ni.samuraigraph.data.SGNetCDFData;
import jp.riken.brain.ni.samuraigraph.data.SGNetCDFFile;

/**
 *
 * @author kuromaru
 */
public class SGPropertyFileNetCDFDataDialog extends SGPropertyFileDataDialog {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = 7603514995179107362L;

    /** Creates new form SGPropertyFileNetCDFDataDialog */
    public SGPropertyFileNetCDFDataDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /** Creates new form SGPropertyFileNetCDFDataDialog */
    public SGPropertyFileNetCDFDataDialog(java.awt.Dialog parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mButtonPanel = new javax.swing.JPanel();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mNetCDFDataSetupPanel = new jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        mButtonPanel.setFont(new java.awt.Font("Dialog", 0, 11));

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        getContentPane().add(mButtonPanel, gridBagConstraints);
        getContentPane().add(mNetCDFDataSetupPanel, new java.awt.GridBagConstraints());

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupPanel mNetCDFDataSetupPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    // End of variables declaration//GEN-END:variables

    private jp.riken.brain.ni.samuraigraph.base.SGTextField mUnvisibleTextField;
    
    /**
     * Initialize the properties.
     */
    private void initProperty() {
        this.mNetCDFDataSetupPanel.setPopupDialogOwner(this);
        
        this.mUnvisibleTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
    }
    
    @Override
    protected JButton getFileChooserButton() {
        return null;
    }

    @Override
    protected JTextComponent getFileNameTextComponent() {
        return null;
    }

    protected JButton getCancelButton() {
        return this.mCancelButton;
    }

    protected JButton getOKButton() {
        return this.mOKButton;
    }

    protected SGIDataSetupTableHolder getDataSetupTableHolder() {
        return this.mNetCDFDataSetupPanel;
    }

    /**
     * Sets the netCDF data.
     * 
     * @param fileName
     *           the name of data file
     * @param ncFile
     *           the netCDF data
     * @param dataType
     *            type of data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(String fileName, SGNetCDFFile ncFile, String dataType,
    		SGDataColumnInfoSet colInfoSet,
            Map<String, Object> infoMap, final boolean showDefault) {
        
        // set the data type and information map
        this.setDataType(dataType, infoMap);

        // set the file name
        this.setFileName(fileName);
        
        if (this.mNetCDFDataSetupPanel.setData(ncFile, dataType, colInfoSet,
        		infoMap, showDefault) == false) {
            return false;
        }
        
        return true;
    }

    /**
     * Set information of data columns.
     * 
     * @param fileName
     *           the name of data file
     * @param data
     *            netCDF data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(String fileName, SGNetCDFData data, 
            SGDataColumnInfoSet colInfoSet,
            Map<String, Object> infoMap, final boolean showDefault) {

        // set data
        if (this.setData(fileName, data.getNetcdfFile(), data.getDataType(), 
        		colInfoSet, infoMap, showDefault) == false) {
            return false;
        }

        return true;
    }
    
    @Override
    protected boolean isAcceptable(String fileName) {
        return true;
    }
    
    @Override
    protected String getFileName() {
        return this.mUnvisibleTextField.getText();
    }
    
    @Override
    protected void setFileName(final String fileName) {
        this.mUnvisibleTextField.setText(fileName);
    }
    
    public Integer getMultipleDimensionStart() {
        return this.mNetCDFDataSetupPanel.getMultipleDimensionStart();
    }
    
    public Integer getMultipleDimensionEnd() {
        return this.mNetCDFDataSetupPanel.getMultipleDimensionEnd();
    }
    
    public Integer getMultipleDimensionStep() {
        return this.mNetCDFDataSetupPanel.getMultipleDimensionStep();
    }
}
