package jp.riken.brain.ni.samuraigraph.base;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.DateFormat;
import java.text.NumberFormat;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.StringTokenizer;

import javax.print.attribute.standard.MediaSize;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import jp.riken.brain.ni.samuraigraph.base.SGCSVTokenizer.Token;

import org.w3c.dom.Document;
import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * A class with utility methods which are used to transform a text string into a
 * value such as number or color, and vice versa.
 * 
 */
public class SGUtilityText implements SGIConstants, SGIDrawingElementConstants,
        SGIPropertyFileConstants {

    /**
     * Array of default available date format.
     */
    public static final String[] DEFAULT_DATE_FORMAT_ARRAY = { "yy/MM/dd",
            "yy.MM.dd", "yy-MM-dd", "yyyyMMdd", "yyMMdd", "yy MM dd",
            "yyyy MM dd" };

    // public static final DateFormat[] DEFAULT_DATE_FORMAT_ARRAY = {
    // DateFormat.getDateInstance( DateFormat.SHORT ),
    // new SimpleDateFormat("yy.MM.dd"),
    // new SimpleDateFormat("yy-MM-dd"),
    // new SimpleDateFormat("yyyyMMdd"),
    // new SimpleDateFormat("yyMMdd"),
    // new SimpleDateFormat("yy MM dd"),
    // new SimpleDateFormat("yyyy MM dd")
    // };

    // list of date format
    private static final List<DateFormat> DATE_FORMAT_ARRAY_LIST = new ArrayList<DateFormat>();

    // /**
    // *
    // * @param args
    // */
    // public static void main(String[] args) throws Exception
    // {
    // System.out.println("<< start >>");
    //
    // String str = "1.0 inch";
    // Number num = getLength( str, "pt" );
    // System.out.println(num);
    //
    // /*
    // String[] strArray = {
    // "2005/05/01",
    // "05/05/01",
    // "05/5/1",
    // "2005.05.01",
    // "05.05.01",
    // "05.5.1",
    // "2005-05-01",
    // "2005-5-1",
    // "05-05-01",
    // "05-5-1",
    // "20050501",
    // "050501",
    // "2005 05 01",
    // "05 05 01"
    // };
    //
    // for( int ii=0; ii<strArray.length; ii++ )
    // {
    // System.out.println( SGUtilityText.getDate( strArray[ii] ) + " " +
    // strArray[ii] );
    // }
    // */
    //
    //
    // /*
    // Locale[] array = {
    // Locale.US, Locale.GERMANY, Locale.FRANCE, Locale.JAPAN, Locale.CHINESE,
    // Locale.ITALIAN };
    // for( int ii=0; ii<array.length; ii++ )
    // {
    // Locale currentLocale = array[ii];
    // SimpleDateFormat formatter
    // = new SimpleDateFormat( "yyyy MMMM dd EEEE", currentLocale );
    // Date today = new Date();
    // String result = formatter.format( today );
    // System.out.println( "Locale: " + currentLocale.toString() );
    // System.out.println( "Result: " + result );
    // System.out.println();
    // }
    // */
    //
    // /*
    // char[] cArray = {
    // 'a', 'b', 'c', '\\', '"', '\t', 'd', 'e', 'f', ' ',
    // '"', 'g', 'h', 'i', ' ', 'j', 'k', 'l',
    // ' ', 'm', 'n', ' ', '"', 'o', 'p', 'q', ' ',
    // '"', 'r', 's', 't', ' ', '"', 'u', '\f', 'v', 'w', ' ', 'x'
    // };
    // */
    //
    // /*
    // char[] cArray = {
    // 'a', 'b', 'c', '"', 'd', 'e', 'f', ' ', 'g', 'h', 'i', '"'
    // };
    // */
    //
    //
    //
    // /*
    // // String str = "0.0 0.0 -1.0 1.0 \"a\"";
    // // String str = "0.0 0.0\r1.0 1.0\n2.0 0.5\r\n3.0 2.0\r\n\r\n4.0 4.0";
    // // String str = new String(cArray);
    // //System.out.println(str);
    // //System.out.println();
    //
    // StringReader sr = new StringReader(str);
    // final BufferedReader br = new BufferedReader(sr);
    // System.out.println("*****");
    // String line = null;
    // while( (line=SGUtilityText.readLine(br))!=null )
    // {
    // System.out.println(line);
    // }
    // System.out.println("*****");
    // System.out.println();
    // */
    //
    //
    // /*
    // ArrayList strList = new ArrayList();
    // SGUtilityText.tokenize(str,strList);
    //
    // System.out.println();
    // for( int ii=0; ii<strList.size(); ii++ )
    // {
    // String s = (String)strList.get(ii);
    // // System.out.println(ii+" *"+s+"*");
    // }
    // System.out.println(strList);
    // */
    //
    //
    // /*
    // String str = "G^{(0)}_n(x_i,y_j) = x_i^{n-1}+y_j^n-1";
    //
    // ArrayList charList = new ArrayList();
    // ArrayList superList = new ArrayList();
    // ArrayList subList = new ArrayList();
    // SGUtilityText.getSubscriptAndSuperscriptInfo(str,charList,superList,subList);
    //
    // if( charList.size() != superList.size() )
    // {
    // throw new Error();
    // }
    // if( superList.size()!=subList.size() )
    // {
    // throw new Error();
    // }
    //
    // System.out.println();
    // System.out.println(str);
    // System.out.println();
    // for( int ii=0; ii<charList.size(); ii++ )
    // {
    // System.out.println(ii+" "+charList.get(ii)+" "+superList.get(ii)+"
    // "+subList.get(ii) );
    // }
    // System.out.println();
    // */
    //
    // /*
    // String str = "+.40e03";
    // Number num = SGUtilityText.getDouble(str);
    // System.out.println(num);
    // */
    //
    //
    // /*
    // String str = "aaa 345 \"\" bbb ccc";
    // ArrayList strList = new ArrayList();
    // SGUtilityText.tokenize(str,strList);
    // System.out.println(strList);
    // */
    //
    // /*
    // String str = "1.0 pt";
    // String s = removeUnit( str, str );
    // System.out.println("*"+s+"*");
    // */
    //
    //
    // }

    /**
     * Create a string with superscript.
     * @param base
     *             a base string
     * @param sp
     *             a string for superscript
     */
    public static String getSuperscriptString(final String base, final String sp) {
	StringBuffer sb = new StringBuffer();
	sb.append(base);
	sb.append("^{");
	sb.append(sp);
	sb.append("}");
	return sb.toString();
//        String str = a + "^{" + b + "}";
//        return str;
    }

    /**
     * Create a string with subscript.
     * @param base
     *             a base string
     * @param sub
     *             a string for subscript
     */
    public static String getSubscriptString(final String base, final String sub) {
	StringBuffer sb = new StringBuffer();
	sb.append(base);
	sb.append("_{");
	sb.append(sub);
	sb.append("}");
	return sb.toString();
//        String str = a + "_{" + b + "}";
//        return str;
    }

    /**
     * 
     * @param line
     *            A line.
     * @param bseList
     *            List of base strings.
     * @param superList
     *            List of superscript strings.
     * @param subList
     *            List of subscript strings.
     * @return
     */
    public static boolean getSubscriptAndSuperscriptInfo(final String line,
            final ArrayList baseList, final ArrayList superList,
            final ArrayList subList) {

        if (line == null || baseList == null || superList == null
                || subList == null) {
            return false;
        }
        if (line.length() == 0) {
            return false;
        }

        // working variables
        char c;
        int len = line.length();
        boolean in_super = false;
        boolean in_sub = false;
        boolean in_brace = false;
        boolean in_escape = false;
        int in_brace_stack = 0;
//        String cache_base = "";
//        String cache_super = "";
//        String cache_sub = "";
        StringBuffer cache_base = new StringBuffer();
        StringBuffer cache_super = new StringBuffer();
        StringBuffer cache_sub = new StringBuffer();

        for (int i = 0; i < len; i++) {
            c = line.charAt(i);
            if (in_super || in_sub) {
                if (in_brace) {
                    if (in_escape) {
                        if (in_super) {
//                            cache_super += '\\';
//                            cache_super += c;
                            cache_super.append('\\');
                            cache_super.append(c);
                        } else {
//                            cache_sub += '\\';
//                            cache_sub += c;
                            cache_sub.append('\\');
                            cache_sub.append(c);
                        }
                        in_escape = false;
                    } else {
                        if (c == '\\') {
                            in_escape = true;
                        } else {
                            if (c == '}' && in_brace_stack == 0) {
                                in_brace = false;
                                in_super = false;
                                in_sub = false;
                            } else {
                                if (c == '}')
                                    in_brace_stack--;
                                if (c == '{')
                                    in_brace_stack++;
                                if (in_super) {
//                                    cache_super += c;
                                    cache_super.append(c);
                                } else {
//                                    cache_sub += c;
                                    cache_sub.append(c);
                                }
                            }
                        }
                    }
                } else if (c == '{') {
                    in_brace = true;
                    in_brace_stack = 0;
                } else {
                    if (in_escape == false) {
                        if (c == '\\') {
                            in_escape = true;
                        } else {
                            if (in_super) {
//                                cache_super += c;
                                cache_super.append(c);
                                in_super = false;
                            } else {
//                                cache_sub += c;
                                cache_sub.append(c);
                                in_sub = false;
                            }
                        }
                    } else {
                        if (in_super) {
//                            cache_super += '\\';
//                            cache_super += c;
                            cache_super.append('\\');
                            cache_super.append(c);
                            in_super = false;
                        } else {
//                            cache_sub += '\\';
//                            cache_sub += c;
                            cache_sub.append('\\');
                            cache_sub.append(c);
                            in_sub = false;
                        }
                        in_escape = false;
                    }
                }
            } else {
                if (c == '^' && in_escape == false) {
                    if (cache_base.length() == 0 || cache_super.length() != 0) {
                        return false;
                    }
                    in_super = true;
                } else if (c == '_' && in_escape == false) {
                    if (cache_base.length() == 0 || cache_sub.length() != 0) {
                        return false;
                    }
                    in_sub = true;
                } else {
                    if (c == '\\' && in_escape == false) {
                        in_escape = true;
                    } else {
                        if (cache_super.length() != 0
                                || cache_sub.length() != 0) {
                            // store cache string
                            baseList.add(cache_base.toString());
                            if (cache_super.length() != 0) {
                                superList.add(cache_super.toString());
                            } else {
                                superList.add(null);
                            }
                            if (cache_sub.length() != 0) {
                                subList.add(cache_sub.toString());
                            } else {
                                subList.add(null);
                            }
                            // reset string cache
//                            cache_base = "";
//                            cache_super = "";
//                            cache_sub = "";
                            cache_base.setLength(0);;
                            cache_super.setLength(0);
                            cache_sub.setLength(0);
                        }
//                        cache_base += c;
                        cache_base.append(c);
                        in_escape = false;
                    }
                }
            }
        }
        if (in_super || in_sub || in_brace || in_escape) {
            return false;
        }

        // flush cache strings..
        if (cache_base.length() != 0) {
            // store cache string
            baseList.add(cache_base.toString());
            if (cache_super.length() != 0) {
                superList.add(cache_super.toString());
            } else {
                superList.add(null);
            }
            if (cache_sub.length() != 0) {
                subList.add(cache_sub.toString());
            } else {
                subList.add(null);
            }
        }
        return true;
    }

    /**
     * get unescape string
     * 
     * @return
     */
    public static final String unescapeString(final String str) {
//        String ret = "";
	StringBuffer sb = new StringBuffer();
        boolean in_escape = false;
        for (int ii = 0; ii < str.length(); ii++) {
            char c = str.charAt(ii);
            if (in_escape) {
//                ret += c;
        	sb.append(c);
                in_escape = false;
            } else {
                if (c == '\\') {
                    in_escape = true;
                } else {
//                    ret += c;
                    sb.append(c);
                }
            }
        }
//        return ret;
        return sb.toString();
    }

    public static boolean tokenize(final String str, final List<Token> tokenList,
            final boolean isDataFile) {

        if (str == null || tokenList == null) {
            throw new IllegalArgumentException("str==null || tokenList==null");
        }

        if (str.length() == 0) {
            return true;
        }
        if (count(str, '"') % 2 != 0) {
            return false;
        }
        
        SGCSVTokenizer csvt = new SGCSVTokenizer(str, isDataFile);
        while (csvt.hasMoreTokens()) {
            try {
                Token result = csvt.nextToken();
                tokenList.add(result);
            } catch (NoSuchElementException e) {
            }
        }
        return true;
    }

    /**
     * 
     * @param charList
     * @return
     */
    public static String createString(final ArrayList charList) {
        final char[] cArray = new char[charList.size()];
        for (int ii = 0; ii < cArray.length; ii++) {
            cArray[ii] = ((Character) charList.get(ii)).charValue();
        }
        final String str = new String(cArray);
        return str;
    }

    /**
     * Read a line with finite length and with any character other than spaces.
     * 
     * @param br
     *           a buffered reader object
     * @return a line
     */
    public static String readLine(final BufferedReader br) {
        String line = null;
        try {
            while (true) {
            	// read a line
                line = br.readLine();
                
                // the end of file
                if (line == null) {
                	break;
                }

                // a line that contains only spaces
                boolean spacesOnly = true;
                char[] cArray = line.toCharArray();
                for (int ii = 0; ii < line.length(); ii++) {
                	if (!Character.isSpaceChar(cArray[ii])) {
                		spacesOnly = false;
                		break;
                	}
                }
                if (spacesOnly) {
                	continue;
                }
                
                // a line with finite length
                if (line.length() != 0) {
                    break;
                }
            }
        } catch (IOException ex) {
            return null;
        }
        return line;
    }

    /**
     * Create a string representation of a list of color objects 
     * in a format of "{(r1,g1,b1,a1),(r2,g2,b2,a2),...}".
     * @param colorList
     *                  a list of colors
     * @return
     *                  a string representation of a list of color objects
     */
    public static String getColorListString(final List colorList) {
//        String str = "{";
	StringBuffer sb = new StringBuffer();
	sb.append('{');
        for (int ii = 0; ii < colorList.size(); ii++) {
            final Color color = (Color) colorList.get(ii);
            final String strColor = SGUtilityText.getColorString(color);
//            str += strColor;
            sb.append(strColor);
            if (ii != colorList.size() - 1) {
//                str += ',';
        	sb.append(',');
            } else {
//                str += "}";
        	sb.append('}');
            }
        }

//        return str;
        return sb.toString();
    }

    /**
     * Write the information of a color list in a format of
     * "key={(r1,g1,b1,a1),(r2,g2,b2,a2),...}" to the writer object.
     * @param writer
     *               a writer object
     * @param key
     *               the key
     * @param colorList
     *               the color list
     * @return
     *               true if succeeded
     */
    public static boolean writeColorListPropertyLine(final Writer writer,
            final String key, final List colorList) throws IOException {
        writer.write(key);
        writer.write("=");
        String str = getColorListString(colorList);
        writer.write(str);
        writer.write("\n");
        return true;
    }

    /**
     * Search the start character from the head of a given string
     * and the end character from the tail of the string, respectively.
     * If both of them are found, returns a string between them.
     * 
     * @param str
     *            a string
     * @param sChar
     *            the start character
     * @param eChar
     *            the end character
     * @return a substring if it exists, or null if not found
     */
    public static String getInnerString(final String str, final int sChar,
            final int eChar) {
        if (str == null) {
            return null;
        }
        if (str.length() < 2) {
            return null;
        }
        int start = str.indexOf(sChar) + 1;
        if (start == -1) {
            return null;
        }
        int end = str.lastIndexOf(eChar);
        if (end == -1) {
            return null;
        }
        if (end <= start) {
            return null;
        }
        String sub = str.substring(start, end);
        return sub;
    }
    
    /**
     * Search a open bracket from the head of a given string
     * and a closed bracket from the tail of the string, respectively.
     * If both of them are found, parses the text string between them 
     * and creates an array of text strings between a bracket.
     * Spaces on the both side of each string are removed.
     * 
     * @param str
     *           a text string
     * @return an array of text strings if parsing succeeded
     */
    public static String[] getStringsInBracket(final String str) {
        if (str == null) {
            return null;
        }
        String sub = SGUtilityText.getInnerString(str, '(', ')');
        if (sub == null) {
            return null;
        }
        String[] sArray = sub.split(",");
        for (int ii = 0; ii < sArray.length; ii++) {
        	sArray[ii] = sArray[ii].trim();
        }
        return sArray;
    }

    /**
     * Parses a given text string and creates an array of integers.
     * 
     * @param str
     *           a text string
     * @return an array of integer if parsing succeeded
     */
    public static int[] getIntegerArray(final String str) {
        if (str == null) {
            return null;
        }
        String[] strArray = getStringsInBracket(str);
        if (strArray == null) {
            return null;
        }

        int[] array = new int[strArray.length];
        for (int ii = 0; ii < array.length; ii++) {
            Integer num = SGUtilityText.getInteger(strArray[ii]);
            if (num == null) {
                return null;
            }
            array[ii] = num.intValue();
        }

        return array;
    }
    
    /**
     * Parses a given text string and creates an array of float numbers.
     * 
     * @param str
     *           a text string
     * @return an array of float numbers if parsing succeeded
     */
    public static float[] getFloatArray(final String str) {
        if (str == null) {
            return null;
        }
        String[] strArray = getStringsInBracket(str);
        if (strArray == null) {
            return null;
        }

        float[] array = new float[strArray.length];
        for (int ii = 0; ii < array.length; ii++) {
            Float num = SGUtilityText.getFloat(strArray[ii]);
            if (num == null) {
                return null;
            }
            array[ii] = num.floatValue();
        }

        return array;
    }

    /**
     * Parses a given text string and creates an array of double numbers.
     * 
     * @param str
     *           a text string
     * @return an array of double numbers if parsing succeeded
     */
    public static double[] getDoubleArray(final String str) {
        if (str == null) {
            return null;
        }
        String[] strArray = getStringsInBracket(str);
        if (strArray == null) {
            return null;
        }

        double[] array = new double[strArray.length];
        for (int ii = 0; ii < array.length; ii++) {
            Double num = SGUtilityText.getDouble(strArray[ii]);
            if (num == null) {
                return null;
            }
            array[ii] = num.doubleValue();
        }

        return array;
    }

    /**
     * Parses a given text string in a format of "(r,g,b)" or "(r,g,b,a)" 
     * and creates a color object.
     * 
     * @param str
     *           a text string
     * @return a color object if parsing succeeds
     */
    public static Color parseColor(final String str) {
        final int[] array = getIntegerArray(str);
        if (array == null) {
            return null;
        }
        final int len = array.length;
        if (len != 4 && len != 3) {
            return null;
        }
        for (int ii = 0; ii < len; ii++) {
            if (array[ii] < 0 || array[ii] > 255) {
                return null;
            }
        }

        Color color = null;
        if (len == 3) {
            color = new Color(array[0], array[1], array[2]);
        } else if (len == 4) {
            color = new Color(array[0], array[1], array[2], array[3]);
        }

        return color;
    }

    /**
     * Create a string representation of a color object from a given string
     * in a format of "(r,g,b,a)".
     * @param color
     *              a color object
     * @return
     *              a string representation of a given color
     */
    public static String getColorString(final Color color) {
	if (color == null) {
	    return null;
	}
//        final String strColor = new String("(" + color.getRed() + ","
//                + color.getGreen() + "," + color.getBlue() + ","
//                + color.getAlpha() + ")");
        StringBuffer sb = new StringBuffer();
        sb.append('(');
        sb.append(color.getRed());
        sb.append(',');
        sb.append(color.getGreen());
        sb.append(',');
        sb.append(color.getBlue());
        sb.append(',');
        sb.append(color.getAlpha());
        sb.append(')');
//        return strColor;
        return sb.toString();
    }

    /**
     * 
     * @param value
     * @return Boolean instance. null if failed.
     */
    public static Boolean getBoolean(final String value) {
        if (value == null) {
            return null;
        }
        Boolean b = null;
        if (Boolean.TRUE.toString().equalsIgnoreCase(value)) {
            b = Boolean.TRUE;
        } else if (Boolean.FALSE.toString().equalsIgnoreCase(value)) {
            b = Boolean.FALSE;
        } else {
            return null;
        }
        return b;
    }

    /**
     * 
     */
    public static Integer getInteger(final String value) {
        Number num = parse(value);
        if (num == null) {
            return null;
        }
        return Integer.valueOf(num.intValue());
    }

    /**
     * 
     */
    public static Float getFloat(final String value) {
        Number num = parse(value);
        if (num == null) {
            return null;
        }
        return Float.valueOf(num.floatValue());
    }
    
    /**
     * Parse a text string and returns a double-precision floating-point number.
     */
    public static Double getDouble(final String value) {
        if (value == null) {
            return null;
        }
        if (SGITextDataConstants.NOT_A_NUMBER_VALUE.equalsIgnoreCase(value)) {
            return Double.NaN;
        }
        Number num = parse(value);
        if (num == null) {
            return null;
        }
        return Double.valueOf(num.doubleValue());
    }

    /**
     * Create a string in a CVS format from a given string separated with spaces or tabs.
     * @param value
     *              a given string
     * @return
     *              a string in a CVS format
     */
    public static String getCSVString(final String value) {
	if (value == null) {
	    return null;
	}
        final String space = " ";
        final String tab = "\t";
        boolean use_quote = false;
//        String str = "";
        StringBuffer sb = new StringBuffer();
        for (int ii = 0; ii < value.length(); ii++) {
            char c = value.charAt(ii);
            if (c == ',') {
                use_quote = true;
            } else if (c == '"') {
                use_quote = true;
//                str += '"';
                sb.append('"');
            }
//            str += c;
            sb.append(c);
        }
        if (value.startsWith(space) || value.startsWith(tab)
                || value.endsWith(space) || value.endsWith(tab)) {
            use_quote = true;
        }
        if (use_quote) {
//            str = "\"" + str + "\"";
            String str = sb.toString();
            sb.append("\"");
            sb.append(str);
            sb.append("\"");
        }
//        return str;
        return sb.toString();
    }

    /**
     * 
     * @param line
     * @return
     */
    public static List<Color> getColorList(final String line) {
        String sub = SGUtilityText.getInnerString(line, '{', '}');
        if (sub == null) {
            return null;
        }

        ArrayList<String> strColorList = SGUtilityText
                .getStringListFromCommaSeparatedLine(sub);
        ArrayList<Color> colorList = new ArrayList<Color>();
        for (int ii = 0; ii < strColorList.size(); ii++) {
            String strColor = (String) strColorList.get(ii);
            Color color = SGUtilityText.parseColor(strColor);
            colorList.add(color);
        }

        return colorList;
    }

    /**
     * Create a list of strings from a given string separated with commas such as
     * (str1),(str2),...,(strN).
     * @param line
     *             a string
     * @return
     *             a list of strings
     */
    public static ArrayList<String> getStringListFromCommaSeparatedLine(String line) {
        int fromIndex = 0;
        int begin;
        int end;
        ArrayList<String> strList = new ArrayList<String>();
        while (true) {
            begin = line.indexOf("(", fromIndex);
            end = line.indexOf(")", fromIndex);
            if (begin >= end) {
                break;
            }
            String sub = line.substring(begin, end + 1);
            if (sub == null) {
                break;
            }
            strList.add(sub);
            fromIndex = end + 1;
        }
        return strList;
    }

    /**
     * Returns whether a given font style is valid.
     * 
     * @param style
     *           a font style
     * @return true if the given font style is valid
     */
    public static boolean isValidFontStyle(final int style) {
        final int[] array = {
                Font.PLAIN, Font.BOLD, Font.ITALIC, (Font.BOLD | Font.ITALIC)
        };
        for (int ii = 0; ii < array.length; ii++) {
            if (style == array[ii]) {
                return true;
            }
        }
        return false;
    }

    /**
     * Returns the name of a given font style.
     * 
     * @param style
     *           a font style
     * @return the name of a given font style
     */
    public static String getFontStyleName(final int style) {
        String name = null;
        switch (style) {
        case Font.PLAIN:
            name = FONT_PLAIN;
            break;
        case (Font.BOLD | Font.ITALIC):
            name = FONT_BOLD_ITALIC;
            break;
        case Font.BOLD:
            name = FONT_BOLD;
            break;
        case Font.ITALIC:
            name = FONT_ITALIC;
        default:
        }
        return name;
    }

    /**
     * Returns the font style fron a given name.
     * 
     * @param name
     *           the name of a font style
     * @return the font style
     */
    public static Integer getFontStyle(final String name) {
        if (name == null) {
            return null;
        }
        Integer style = null;
        if (SGUtilityText.isEqualString(FONT_PLAIN, name)) {
        	style = Font.PLAIN;
        } else if (SGUtilityText.isEqualString(FONT_BOLD, name)) {
            style = Font.BOLD;
        } else if (SGUtilityText.isEqualString(FONT_ITALIC, name)) {
            style = Font.ITALIC;
        } else if (SGUtilityText.isEqualString(FONT_BOLD_ITALIC, name)) {
            style = Font.BOLD | Font.ITALIC;
        }
        return style;
    }

    /**
     * 
     */
    public static String getScaleTypeName(final int type) {

        String name = null;
        switch (type) {
        case SGAxis.LINEAR_SCALE: {
            name = SGIConstants.SCALE_TYPE_LINEAR;
            break;
        }

        case SGAxis.LOG_SCALE: {
            name = SGIConstants.SCALE_TYPE_LOG;
            break;
        }

        default: {

        }
        }

        return name;
    }

    /**
     * Returns the scale type ID from the name.
     * 
     * @param name
     *           the name of scale type
     * @return the scale type ID
     */
    public static int getScaleType(final String name) {
        if (name == null) {
            return -1;
        }
        int type = -1;
        if (SCALE_TYPE_LINEAR.equalsIgnoreCase(name)) {
            type = SGAxis.LINEAR_SCALE;
        } else if (SCALE_TYPE_LOG.equalsIgnoreCase(name)) {
            type = SGAxis.LOG_SCALE;
        }
        return type;
    }

    /**
     * 
     * @param spec
     * @return
     */
    public static Document getDocument(String spec) {
        Document doc = null;

        // create an URL instance
        try {
            URL url = new URL(spec);
            doc = getDocument(url);
        } catch (MalformedURLException ex) {
            return null;
        }

        return doc;
    }

    /**
     * property entity resolver
     * 
     * @author okumura
     * 
     */
    private static class PropertyEntityResolver implements EntityResolver {
        public InputSource resolveEntity(final String publicId,
                final String systemId) throws SAXException, IOException {
            if (publicId.startsWith(PROPERTY_FILE_PUBLIC_ID)
                    && systemId.startsWith(PROPERTY_FILE_SYSTEM_ID)) {
                String name = SGIConstants.RESOURCES_DIRNAME
                        + PROPERTY_DTD_FILE_NAME;
                InputStream in = this.getClass().getResourceAsStream(name);
                return new InputSource(in);
            }
            return null;
        }
    }

    private static EntityResolver mPropertyEntityResolver = new PropertyEntityResolver();

    /**
     * Return Document object from given URL.
     * 
     * @param url URL of input stream
     * @return Document. null if failed.
     * @throws Exception
     */
    public static Document getDocument(URL url) {
        Document doc = null;
        InputStream bis = null;
        // get input stream
        try {
            bis = new BufferedInputStream(url.openStream());
        } catch (IOException ex) {
            ex.printStackTrace();
            return null;
        }
        // parse input and create a Document object
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory
                    .newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            builder.setEntityResolver(SGUtilityText.mPropertyEntityResolver);
            doc = builder.parse(bis, url.toString());
        } catch (Exception ex) {
            return null;
        } finally {
            // close the input stream
            try {
                if (bis != null)
                    bis.close();
            } catch (IOException ex) {
            }
        }

        return doc;
    }
    
    /**
     * Return Document object which is converted given string to.
     * 
     * @param documentString XML string
     * @return Document. null if failed.
     */
    public static Document getDocumentFromString(String documentString) {
        Document doc = null;
        InputStream bis = null;
        // parse input and create a Document object
        try {
            bis = new BufferedInputStream(new ByteArrayInputStream(documentString.getBytes("UTF-8")));
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            builder.setEntityResolver(SGUtilityText.mPropertyEntityResolver);
            doc = builder.parse(bis);
        } catch (ParserConfigurationException ex) {
            return null;
        } catch (IOException ex) {
            return null;
        } catch (SAXException ex) {
            return null;
        } finally {
            // close the input stream
            try {
                if (bis != null)
                    bis.close();
            } catch (IOException ex) {
            }
        }
        
        return doc;
    }

    /**
     * 
     * @param str
     * @return
     */
    private static Number parse(final String str) {
        if (str == null) {
            return null;
        }

        String strNew = str;

        // remove the first character of '+'
        if (str.startsWith("+")) {
            if (str.length() > 1) {
                strNew = strNew.substring(1);
            }
        }

        // from e to E
        strNew = strNew.toUpperCase();

        // from E+ to E
        strNew = strNew.replaceAll("E\\+", "E");

        // parse the string
        ParsePosition pos = new ParsePosition(0);
        Number num = NumberFormat.getInstance().parse(strNew, pos);
        if (pos.getIndex() != strNew.length()) {
            return null;
        }

        return num;
    }

    /**
     * 
     * @param str
     * @return
     */
    public static Number getLengthInPoint(final String str) {
        return getLength(str, pt);
    }

    /**
     * 
     * @param str
     * @return
     */
    public static Number getLength(final String str, final String unit) {
        if (str == null) {
            return null;
        }

        if (str.length() == 0) {
            return null;
        }

        final String ls = str.toLowerCase();
        final String[] units = getUnitsArrayOfLength();
        for (int ii = 0; ii < units.length; ii++) {
            if (ls.endsWith(units[ii])) {
                Number num = removeUnit(ls, units[ii]);
                if (num != null) {
                    return Double.valueOf(convert(num.doubleValue(), units[ii],
                            unit));
                }
            }
        }

        return null;
    }
    
    /**
     * 
     * @param str
     * @param unit
     * @return
     */
    public static Integer getInteger(final String str, final String unit) {
        Number num = SGUtilityText.removeUnit(str, unit);
        if (num == null) {
            return null;
        }
        return Integer.valueOf(num.intValue());
    }

    /**
     * 
     * @param str
     * @param unit
     * @return
     */
    public static Float getFloat(final String str, final String unit) {
        Number num = SGUtilityText.removeUnit(str, unit);
        if (num == null) {
            return null;
        }
        return Float.valueOf(num.floatValue());
    }

    /**
     * 
     * @param str
     * @param unit
     * @return
     */
    public static Double getDouble(final String str, final String unit) {
        Number num = SGUtilityText.removeUnit(str, unit);
        if (num == null) {
            return null;
        }
        return Double.valueOf(num.doubleValue());
    }

    /**
     * Check whether the string is valid.
     * 
     * @param str
     *            a string
     * @return whether the string is valid
     */
    public static boolean isValidString(final String str) {
        if (str == null) {
            return false;
        }

        final int len = str.length();

        // if the length of the string equals to zero
        if (len == 0) {
            return false;
        }

        // if the string consists of spaces
        boolean flag = false;
        for (int ii = 0; ii < len; ii++) {
            final char c = str.charAt(ii);
            if (c != ' ' && c != twoByteSpaceChar && c != '\t' && c != '\n'
                    && c != '\r' && c != '\f') {
                flag = true;
                break;
            }
        }
        if (!flag) {
            return false;
        }

        return true;
    }

    /**
     * Creates sequentially-numbered name in a given name list.
     * 
     * @param list
     *             a name list
     * @param name
     *             a name
     * @return sequentially-numbered name
     */
    public static String getSerialName(List<String> list, final String name) {
        int max = -1;
        for (int ii = 0; ii < list.size(); ii++) {
            String str = list.get(ii);
            if (str.startsWith(name)) {
                String sub = str.substring(name.length());
                if (sub.startsWith("(") && sub.endsWith(")")) {
                    String sub2 = sub.substring(1, sub.length() - 1);
                    Integer index = SGUtilityText.getInteger(sub2);
                    if (index != null) {
                        int n = index.intValue();
                        if (n > max) {
                            max = n;
                        }
                    }
                } else if ("".equals(sub)) {
                    max = 0;
                }
            }
        }

        String nameNew;
        if (max != -1) {
            max++;
            StringBuffer sb = new StringBuffer();
            sb.append(name);
            sb.append('(');
            sb.append(max);
            sb.append(')');
            nameNew = sb.toString();
        } else {
            nameNew = name;
        }

        return nameNew;
    }

    /**
     * Add an available date format
     * 
     * @param format
     */
    public static void addAvailableDateFormat(final String format) {
        DATE_FORMAT_ARRAY_LIST.add(new SimpleDateFormat(format));
    }

    /**
     * Parse the string and returns a Date object.
     * 
     * @param str -
     *            a text string to be parsed
     * @return a Date object
     */
    public static Date getDate(final String str) {
        Date date = null;

        List<DateFormat> list = DATE_FORMAT_ARRAY_LIST;
        for (int ii = 0; ii < list.size(); ii++) {
            DateFormat df = (DateFormat) list.get(ii);

            // parse the string
            ParsePosition pos = new ParsePosition(0);
            Date d = df.parse(str, pos);
            if (pos.getIndex() == str.length()) {
                if (d != null) {
                    date = d;
                    break;
                }
            }
        }

        return date;
    }

    /**
     * 
     * @return
     */
    public static String[] getUnitsArrayOfLength() {
        return new String[] { SGIConstants.cm, SGIConstants.mm,
                SGIConstants.pt, SGIConstants.inch };
    }

    /**
     * 
     * @param unit
     * @return
     */
    public static boolean isLengthUnit(final String unit) {
        if (unit == null) {
            throw new IllegalArgumentException();
        }
        final String[] array = SGUtilityText.getUnitsArrayOfLength();
        boolean flag = false;
        for (int ii = 0; ii < array.length; ii++) {
            if (array[ii].equalsIgnoreCase(unit)) {
                flag = true;
                break;
            }
        }
        return flag;
    }

    /**
     * 
     * @param value
     * @param unitOld
     * @param unitNew
     * @return
     */
    public static double convert(final double value, final String unitOld,
            final String unitNew) {
        // check
        if (unitOld == null || unitNew == null) {
            throw new IllegalArgumentException();
        }

        if (!isLengthUnit(unitOld) || !isLengthUnit(unitNew)) {
            throw new IllegalArgumentException();
        }

//        final String uOld = unitOld.toLowerCase();
//        final String uNew = unitNew.toLowerCase();

        // no needs of conversion
        if (unitOld.equalsIgnoreCase(unitNew)) {
            return value;
        }

        final String[] units = SGUtilityText.getUnitsArrayOfLength();
        final float[] ratioArray = { 1.0f, 0.10f, CM_POINT_RATIO, CM_INCH_RATIO };
        int indexOld = -1;
        for (int ii = 0; ii < units.length; ii++) {
            if (units[ii].equalsIgnoreCase(unitOld)) {
                indexOld = ii;
                break;
            }
        }
        if (indexOld == -1) {
            throw new IllegalArgumentException();
        }
        int indexNew = -1;
        for (int ii = 0; ii < units.length; ii++) {
            if (units[ii].equalsIgnoreCase(unitNew)) {
                indexNew = ii;
                break;
            }
        }
        if (indexNew == -1) {
            throw new IllegalArgumentException();
        }

        final float ratio = ratioArray[indexOld] / ratioArray[indexNew];

        return value * ratio;
    }

    /**
     * 
     * @param value
     * @param unit
     * @return
     */
    public static double convertToPoint(final double value, final String unit) {
        return convert(value, unit, pt);
    }

    /**
     * 
     * @param value
     * @param unit
     * @return
     */
    public static double convertFromPoint(final double value, final String unit) {
        return convert(value, pt, unit);
    }

    /**
     * Parse and convert to the given unit. ex. str - 1 inch , unit - cm is
     * converted to "2.54"
     * 
     * @param str -
     *            a string to be parsed
     * @return parsed string
     */
    public static String convertString(final String str, final String unit) {
        if (str == null || unit == null) {
            return null;
        }
        if (str.length() == 0 || unit.length() == 0) {
            return null;
        }

        final String s = str.toLowerCase();
        final String u = unit.toLowerCase();

        // check whether the string ends with the suffix of unit
        String[] unitsArray = SGUtilityText.getUnitsArrayOfLength();
        String suffix = null;
        for (int ii = 0; ii < unitsArray.length; ii++) {
            if (str.endsWith(unitsArray[ii])) {
                suffix = unitsArray[ii];
                break;
            }
        }
        if (suffix == null) {
            return null;
        }

        Number value = SGUtilityText.removeUnit(s, suffix);
        if (value == null) {
            return null;
        }
        final double num = value.doubleValue();

        //
        final double numNew = SGUtilityText.convert(num, suffix, u);
        String valueNew = Double.toString(numNew);

        return valueNew;
    }

    /**
     * Remove the unit from a text string, parse and create a Number object.
     * 
     * @param str -
     *            a text string to be parsed
     * @param unit -
     *            a text string of unit to be removed
     * @return parsed result
     */
    public static Number removeUnit(final String str, final String unit) {
        final String sub = removeSuffix(str, unit);
        if (sub == null) {
            return null;
        }

        //
        final StringTokenizer st = new StringTokenizer(sub);
        final ArrayList tokenList = new ArrayList();
        while (st.hasMoreTokens()) {
            tokenList.add(st.nextToken());
        }
        if (tokenList.size() != 1) {
            return null;
        }
        final String value = (String) tokenList.get(0);

        return SGUtilityText.getDouble(value);
    }

    /**
     * Remove the suffix from a text string.
     * 
     * @param str -
     *            a text string to be parsed
     * @param suffix -
     *            a text string to be removed
     * @return parsed result
     */
    public static String removeSuffix(final String str, final String suffix) {
        if (str == null) {
            return null;
        }
        if (str.length() == 0) {
            return null;
        }
        if (suffix == null) {
            return str;
        }

        if (str.endsWith(suffix) == false) {
            return str;
        }

        // create a new string without suffix
        int index = -1;
        while (true) {
            int num = str.indexOf(suffix, index + 1);
            if (num == -1) {
                break;
            }
            index = num;
        }
        String sub = str.substring(0, index);
        if (sub.length() == 0) {
            return null;
        }

        return sub;
    }

    /**
     * Default colors.
     */
    public static final Color[] DEFAULT_COLORS = { Color.RED, Color.GREEN,
            Color.BLUE, Color.CYAN, Color.MAGENTA, Color.YELLOW, Color.ORANGE,
            Color.PINK, Color.WHITE, Color.LIGHT_GRAY, Color.GRAY,
            Color.DARK_GRAY, Color.BLACK };

    /**
     * Names of default colors.
     */
    public static final String[] DEFAULT_COLOR_NAMES = { "RED", "GREEN",
            "BLUE", "CYAN", "MAGENTA", "YELLOW", "ORANGE", "PINK", "WHITE",
            "LIGHT_GRAY", "GRAY", "DARK_GRAY", "BLACK" };

    /**
     * Returns a color object of given name.
     * 
     * @param name
     *           the name of color
     * @return a color object
     */
    public static Color getColor(final String name) {
        if (name == null) {
            throw new IllegalArgumentException("name==null");
        }
        Color cl = null;
        for (int ii = 0; ii < DEFAULT_COLOR_NAMES.length; ii++) {
            if (SGUtilityText.isEqualString(DEFAULT_COLOR_NAMES[ii], name)) {
                cl = DEFAULT_COLORS[ii];
                break;
            }
        }
        return cl;
    }

    /**
     * Returns a color object with given component.
     * 
     * @param r
     *          the red component
     * @param g
     *          the green component
     * @param b
     *          the blue component
     * @return a color object
     */
    public static Color getColor(final String r, final String g, final String b) {
        Integer nr = getInteger(r);
        if (nr == null) {
            return null;
        }
        Integer ng = getInteger(g);
        if (ng == null) {
            return null;
        }
        Integer nb = getInteger(b);
        if (nb == null) {
            return null;
        }
        if (isValidColor(nr.intValue(), ng.intValue(), nb.intValue()) == false) {
            return null;
        }
        return new Color(nr.intValue(), ng.intValue(), nb.intValue());
    }

    /**
     * Checks whether a given color is valid.
     * 
     * @param r
     *          the red component
     * @param g
     *          the green component
     * @param b
     *          the blue component
     * @return true if a given color is valid
     */
    public static boolean isValidColor(final int r, final int g, final int b) {
        return isValidColorComponent(r) && isValidColorComponent(g) && isValidColorComponent(b);
    }

    private static boolean isValidColorComponent(final int c) {
        return (c >= 0 && c < 256);
    }
    
    /**
     * Returns a color object of
     * given name or
     * given text string in a format of "(r,g,b)" or "(r,g,b,a)".
     * 
     * @param str
     *           the name of color, "(r,g,b)" or "(r,g,b,a)"
     * @return a color object or null if failed
     */
    public static Color parseColorString(final String str) {
        Color color = getColor(str);
        if (null!=color) {
            return color;
        } else {
            return parseColor(str);
        }
    }
    
    /**
     * Returns the media size. If an argument is equal to null or an appropriate media size
     * is not found, this method returns null.
     * 
     * @param str
     *            a text string for the media size
     * @return the media size
     */
    public static final MediaSize getMediaSize(final String str) {
        if (str == null) {
            return null;
        }
        MediaSize size = null;
        if (SGUtilityText.isEqualString(PAPER_SIZE_A4, str)) {
            size = MediaSize.ISO.A4;
        } else if (SGUtilityText.isEqualString(PAPER_SIZE_A3, str)) {
            size = MediaSize.ISO.A3;
        } else if (SGUtilityText.isEqualString(PAPER_SIZE_B5, str)) {
            size = MediaSize.ISO.B5;
        } else if (SGUtilityText.isEqualString(PAPER_SIZE_B4, str)) {
            size = MediaSize.ISO.B4;
        } else if (SGUtilityText.isEqualString(PAPER_SIZE_US_LETTER, str)
                || SGUtilityText.isEqualString(PAPER_SIZE_US_LETTER_SIMPLE, str)) {
            size = MediaSize.NA.LETTER;
        }
        return size;
    }
    
    /**
     * Returns true if a given text string means "Portrait" and returns false if it
     * means "Landscape". Otherwise, returns null.
     * 
     * @param str
     *           a text string for paper direction
     * @return true if a given text string means the portrait direction
     */
    public static final Boolean isPortrait(final String str) {
        if (str == null) {
            return null;
        }
        if (SGUtilityText.isEqualString(PORTRAIT, str)) {
            return Boolean.TRUE;
        } else if (SGUtilityText.isEqualString(LANDSCAPE, str)) {
            return Boolean.FALSE;
        } else {
            return null;
        }
    }

    /**
     * Creates a dimension object from a given string in a format of "(w, h)".
     * 
     * @param str
     *           a text string
     * @return a dimension object if parsing succeeds
     */
    public static Dimension getDimension(final String str) {
        final int[] array = getIntegerArray(str);
        if (array == null) {
            return null;
        }

        final int len = array.length;
        if (len != 2) {
            return null;
        }
        if (array[0] < 0 || array[1] < 0) {
            return null;
        }

        final Dimension dim = new Dimension(array[0], array[1]);
        return dim;
    }

    /**
     * 
     * @param value
     * @return
     */
    public static Number getNumber(final String value, final StringBuffer u) {
        if (value == null) {
            return null;
        }
        String str = value.toLowerCase();

        String unit = null;
        String[] units = SGUtilityText.getUnitsArrayOfLength();
        for (int ii = 0; ii < units.length; ii++) {
            if (str.endsWith(units[ii])) {
                unit = units[ii];
                break;
            }
        }

        if (unit == null) {
            return null;
        }
        u.append(unit);

        Number num = SGUtilityText.removeUnit(str, unit);
        if (num == null) {
            return null;
        }

        return Double.valueOf(num.doubleValue());
    }

    // returns a string of "true" or "false"
    public static String getBooleanString(final String value) {
        final String sTrue = Boolean.TRUE.toString();
        final String sFalse = Boolean.FALSE.toString();
        Number num = SGUtilityText.getInteger(value);

        String ret = null;
        if (num != null) {
            ret = ("0".equals(value) ? sTrue : sFalse);
        } else {
            if (sTrue.equalsIgnoreCase(value)) {
                ret = sTrue;
            } else if (sFalse.equalsIgnoreCase(value)) {
                ret = sFalse;
            }
        }

        return ret;
    }

    // static initializer
    static {
        String[] array = DEFAULT_DATE_FORMAT_ARRAY;
        for (int ii = 0; ii < array.length; ii++) {
            addAvailableDateFormat(array[ii]);
        }
    };

    
    /**
     * Returns a list of tokens of the first line.
     * 
     * @param br
     *           a buffered reader
     * @return a list of tokens
     */
    public static List<Token> getFirstTokenList(BufferedReader br) {
        List<Token> tokenList = new ArrayList<Token>();
        while (true) {
            String line = SGUtilityText.readLine(br);
            if (line == null) {
                break;
            }
            if (count(line, '"') % 2 != 0) {
                return null;
            }

            // tokenize the line
            tokenList.clear();
            SGCSVTokenizer csvt = new SGCSVTokenizer(line, true);
            while (csvt.hasMoreTokens()) {
                try {
                    Token result = csvt.nextToken();
                    tokenList.add(result);
                } catch (NoSuchElementException e) {
                }
            }
            final int size = tokenList.size(); // the number of tokens
            if (size != 0) {
                break;
            }
        }
        return tokenList;
    }

    /**
     * Counts and returns the number of appearance of a given character in a given text string.
     * 
     * @param str
     *           a text string
     * @param ch
     *           a character
     * @return the number of appearance of given character
     */
    public static int count(final String str, final char ch) {
        int cnt = 0;
        final int len = str.length();
        for (int ii = 0; ii < len; ii++) {
            final char c = str.charAt(ii);
            if (c == ch) {
                cnt++;
            }
        }
        return cnt;
    }

    /**
     * Returns whether a given text string is double quoted.
     * 
     * @param str
     *           a text string
     * @return true if a given text string is double quoted
     */
    public static boolean isDoubleQuoted(final String str) {
    	if (str.length() < 2) {
    		return false;
    	}
    	return (str.startsWith("\"") && str.endsWith("\""));
    }
    
    /**
     * Compares only letters and digits in given two text strings and returns whether
     * they are equal.
     * 
     * @param str1
     *           the first text string
     * @param str2
     *           the second text string
     * @return true if two text strings are equal
     */
    public static boolean isEqualString(final String str1, final String str2) {

    	if (str1 == null || str2 == null) {
    		throw new IllegalArgumentException("str1 == null || str2 == null");
    	}
    	
    	List<Character> cList1 = getCharList(str1);
    	List<Character> cList2 = getCharList(str2);
    	
    	return cList1.equals(cList2);
    }
    
    private static List<Character> getCharList(final String str) {
    	// to the upper case
    	final String ucStr = str.toUpperCase();
    	
    	// skip characters other than alphabets and numbers
    	List<Character> cList = new ArrayList<Character>();
    	for (int ii = 0; ii < ucStr.length(); ii++) {
    		final char c = ucStr.charAt(ii);
    		if (Character.isLetterOrDigit(c)) {
    			cList.add(Character.valueOf(c));
    		}
    	}
    	return cList;
    }
    
    private static char[] toArray(final List<Character> cList) {
    	char[] array = new char[cList.size()];
    	for (int ii = 0; ii < array.length; ii++) {
    		array[ii] = cList.get(ii).charValue();
    	}
    	return array;
    }
    
    /**
     * Compares only letters and digits in given two text strings and returns whether
     * a given string starts with given prefix.
     * 
     * @param str
     *           a text string
     * @param prefix
     *           the prefix
     * @return true if the text string starts with the prefix
     */
    public static boolean startsWith(final String str, final String prefix) {
    	
    	if (str == null || prefix == null) {
    		throw new IllegalArgumentException("str == null || prefix == null");
    	}
    	
    	List<Character> cList = getCharList(str);
    	List<Character> cListPrefix = getCharList(prefix);
    	char[] cArray = toArray(cList);
    	char[] cPrefixArray = toArray(cListPrefix);
    	String strNew = new String(cArray);
    	String prefixNew = new String(cPrefixArray);

    	return strNew.startsWith(prefixNew);
    }
    
    /**
     * Return only letters and digits string.
     * @param str
     *           a text string
     * @return only letters and digits string
     */
    public static String getCharString(final String str) {
        if (str == null) {
            throw new IllegalArgumentException("str == null");
        }
        List<Character> cList = getCharList(str);
        char[] cArray = toArray(cList);
        return new String(cArray);
    }
    
    /**
     * This parses comma separated string that separated contents are key=value forms.
     * Return {key, value} string arrays.
     * 
     * ex.) "y=0,x=2" returns { { "y", "0" }, { "x", "2" } }
     * @param str
     * @return
     */
    public static String[][] readStringMaps(final String str) {
        String[] uncsv = str.split(",");
        String[][] result = new String[uncsv.length][2];
        for (int i = 0; i < uncsv.length; i++) {
            String[] unequal = uncsv[i].split("=");
            if (unequal.length>=2) {
                result[i][0] = unequal[0].trim();
                result[i][1] = unequal[1].trim();
            }
        }
        return result;
    }
    
    /**
     * Parses a text string and creates an array of integers.
     * 
     * @param str
     *           a text string
     * @return an array of integers or null if failed to parse
     */
    public static Integer[] parseIndices(final String str) {
        List<Integer> numList = new ArrayList<Integer>();
        if (str.length() != 0) {
            final int start = str.indexOf('{');
            final int end = str.lastIndexOf('}');
            if (start == -1 || end == -1) {
            	Integer num = SGUtilityText.getInteger(str);
            	if (num == null) {
            		return null;
            	}
            	return new Integer[] { num };
            }
            if (start > end) {
                return null;
            }
            String sub = str.substring(start + 1, end);
            StringTokenizer st = new StringTokenizer(sub, ",");
            while (st.hasMoreTokens()) {
                String token = st.nextToken();
                Integer num = SGUtilityText.getInteger(token);
                if (num == null) {
                    return null;
                }
                numList.add(num);
            }
        }
        Integer[] indices = new Integer[numList.size()];
        for (int ii = 0; ii < indices.length; ii++) {
            indices[ii] = (Integer) numList.get(ii);
        }
        return indices;
    }
    
    /**
     * Parses a text string and creates an array of strings.
     * 
     * @param str
     *           a text string
     * @return an array of strings or null if failed to parse
     */
    public static String[] parseStrings(final String str) {
        String[] array = null;
        if (str.length() != 0) {
            final int start = str.indexOf('{');
            final int end = str.lastIndexOf('}');
            if (start == -1 || end == -1) {
                return new String[] { str };
            }
            if (start > end) {
                return null;
            }
            String sub = str.substring(start + 1, end);
            array = sub.split(",");
            for (int ii = 0; ii < array.length; ii++) {
                array[ii] = array[ii].trim();
            }
        }
        return array;
    }

    
    public static void main(String[] args) {
    	
//        String str = "a=\"Hello World\", b=\" test \", c = BOLD";
//        System.out.println("*" + str + "*");
//        
//        ArrayList<Token> tokenList = new ArrayList<Token>();
//        tokenize(str, tokenList, false);
//        
//        for (int ii = 0; ii < tokenList.size(); ii++) {
//            Token tk = tokenList.get(ii);
//            System.out.println(ii + " *" + tk.getString() + "*");
//        }
    	
    	String str1 = "Hello World! 1234 ";
    	String str2 = " HELLO-WORLD !__1234__-";
    	System.out.println(isEqualString(str1, str2));
    }
}
