/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.riken.brain.ni.samuraigraph.data;

import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;

import jp.riken.brain.ni.samuraigraph.base.SGDialog;

/**
 * The base class of attribute dialogs.
 * @author kuromaru
 */
public abstract class SGAbstractAttributeDialog extends SGDialog implements MouseListener {

    public SGAbstractAttributeDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
    }
    
    public SGAbstractAttributeDialog(java.awt.Dialog parent, boolean modal) {
        super(parent, modal);
    }

    protected abstract JButton getCloseButton();

    protected abstract JTextArea getTextArea();

    protected abstract SGAttributePanel getAttributePanel();

    /**
     * Close this dialog.
     */
    protected void onEscKeyTyped() {
        this.setVisible(false);
    }

    /**
     * Called when an action event is invoked.
     *
     * @param e
     *         an action event
     */
    public void actionPerformed(ActionEvent e) {
        Object source = e.getSource();
        if (source.equals(this.getCloseButton())) {
            // close this dialog
            this.setVisible(false);
        }
    }

    /**
     * Called when the mouse click event is invoked.
     *
     * @param e mouse event
     */
    public void mouseClicked(MouseEvent e) {
    }

    /**
     * Called when the mouse press event is invoked.
     *
     * @param e mouse event
     */
    public void mousePressed(MouseEvent e) {
        Object source = e.getSource();
        SGAttributePanel ap = this.getAttributePanel();
        JTable table = ap.getTable();
        if (source.equals(table)) {
            // get the values at pressed row and set them to the text area
            final int row = table.getSelectedRow();
            String text = ap.getRowText(row);
            this.getTextArea().setText(text);
            
            // set the caret position
            SwingUtilities.invokeLater(new Runnable(){
                public void run() {
                    getTextArea().setCaretPosition(0);
                }
            });
        }
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

}
