package jp.riken.brain.ni.samuraigraph.data;

import jp.riken.brain.ni.samuraigraph.base.SGAnimationThread;
import jp.riken.brain.ni.samuraigraph.base.SGIAnimation;

/**
 * A class of the animation.
 * 
 */
public class SGDataAnimationThread extends SGAnimationThread {

    /**
     * Builds an animation thread.
     * 
     * @param animation
     *           an animation data source
     */
    public SGDataAnimationThread(SGIAnimation animation) {
        super(animation);
    }

    /**
     * Builds an animation thread with the same as given animation thread.
     * 
     * @param th
     *          an animation thread to copy
     */
    public SGDataAnimationThread(SGAnimationThread th) {
        super(th);
    }

    /**
     * Saves all changes of this data source.
     *
     */
    public void saveChanges() {
        SGIDataAnimation dAnim = (SGIDataAnimation) this.mAnimation;
        dAnim.saveChanges();
    }

    /**
     * Cancels all changes of this data source.
     *
     */
    public void cancelChanges() {
        SGIDataAnimation dAnim = (SGIDataAnimation) this.mAnimation;
        dAnim.cancelChanges();
    }

}
