package jp.riken.brain.ni.samuraigraph.data;

import jp.riken.brain.ni.samuraigraph.base.SGIData;
import jp.riken.brain.ni.samuraigraph.base.SGValueRange;

public interface SGITwoDimensionalData extends SGIData {

    /**
     * Returns the number of data points.
     * 
     * @return the number of data points
     */
    public int getPointsNumber();

    /**
     * Returns the bounds of x-values.
     * 
     * @return the bounds of x-values
     */
    public SGValueRange getBoundsX();

    /**
     * Returns the bounds of y-values.
     * 
     * @return the bounds of y-values
     */
    public SGValueRange getBoundsY();

    /**
     * Returns the title of X values.
     * @return
     *         the title of X values
     */
    public String getTitleX();
    
    /**
     * Returns the title of Y values.
     * @return
     *         the title of Y values
     */
    public String getTitleY();
	
}
