/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGDuplicationDialog.java
 *
 * Created on 2009/08/31, 16:00:51
 */

package jp.riken.brain.ni.samuraigraph.data;

import java.util.Map;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfo;
import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfoSet;
import jp.riken.brain.ni.samuraigraph.base.SGIConstants;
import jp.riken.brain.ni.samuraigraph.base.SGUtility;
import jp.riken.brain.ni.samuraigraph.base.SGUtilityText;

/**
 * A dialog to duplicate netCDF data.
 *
 */
public class SGNetCDFDataDuplicationDialog extends SGDataDuplicationDialog {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = -7649280544732580706L;
    
    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Setup for Duplication";

    /** Creates new form SGDuplicationDialog */
    public SGNetCDFDataDuplicationDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mDataNamePanel = new javax.swing.JPanel();
        mDataNameLabel = new javax.swing.JLabel();
        mDataNameTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mNetCDFDataSetupPanel = new jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupPanel();
        mButtonPanel = new javax.swing.JPanel();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        mDataNamePanel.setLayout(new java.awt.GridBagLayout());

        mDataNameLabel.setFont(new java.awt.Font("Dialog", 1, 12));
        mDataNameLabel.setText("Data Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mDataNamePanel.add(mDataNameLabel, gridBagConstraints);

        mDataNameTextField.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mDataNamePanel.add(mDataNameTextField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(mDataNamePanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        getContentPane().add(mNetCDFDataSetupPanel, gridBagConstraints);

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mButtonPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private javax.swing.JLabel mDataNameLabel;
    private javax.swing.JPanel mDataNamePanel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mDataNameTextField;
    private jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupPanel mNetCDFDataSetupPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    // End of variables declaration//GEN-END:variables

    /**
     * Initialize the properties.
     */
    private void initProperty() {
        // set the title
        this.setTitle(TITLE);

        // add this dialog as an action event listener of the buttons
        this.getOKButton().addActionListener(this);
        this.getCancelButton().addActionListener(this);
        this.mNetCDFDataSetupPanel.getClearButton().addActionListener(this);
        this.mNetCDFDataSetupPanel.getRestoreButton().addActionListener(this);
        this.mNetCDFDataSetupPanel.getComplementButton().addActionListener(this);

        // add this dialog as a property change event listener of the table
        this.mNetCDFDataSetupPanel.getTable().addPropertyChangeListener(this);
        
        // set the dialog owner
        this.mNetCDFDataSetupPanel.setPopupDialogOwner(this);
    }

    /**
     * Called when the OK button is pressed.
     *
     * @return true if succeeded
     */
    protected JButton getOKButton() {
        return this.mOKButton;
    }

    /**
     * Called when the cancel button is pressed.
     *
     * @return true if succeeded
     */
    protected JButton getCancelButton() {
        return this.mCancelButton;
    }

    /**
     * Returns an object that has a table to setup data.
     * 
     * @return an object that has a table to setup data
     */
    protected SGIDataSetupTableHolder getTableHolder() {
        return this.mNetCDFDataSetupPanel;
    }
    
    /**
     * Returns the text field to set data name.
     * 
     * @return a text field to set the data name
     */
    public JTextField getDataNameTextField() {
        return this.mDataNameTextField;
    }
    
    /**
     * Sets the data to this dialog.
     *
     * @param initName
     *           initial value for the data name
     * @param data
     *           the netCDF data
     * @param colInfoSet
     *           column information
     * @param infoMap
     *           the information map
     * @return true if succeeded
     */
    public boolean setData(String initName, SGNetCDFData data, 
    		SGDataColumnInfoSet colInfoSet, Map<String, Object> infoMap) {
        // set the name
        this.mDataNameTextField.setText(initName);

        // set to the panel
        if (this.mNetCDFDataSetupPanel.setData(data, colInfoSet, infoMap, false
        		) == false) {
            return false;
        }
        return true;
    }
    
    /**
     * Returns selected column types.
     * 
     * @return
     *        selected column types
     */
    public SGDataColumnInfo[] getDataColumnTypes() {
        return this.mNetCDFDataSetupPanel.getDataColumnTypes();
    }

    /**
     * Overrode to check validity of the input value.
     */
    protected boolean onOK() {
        // check the data name
        boolean ok = true;
        String name = this.getDataName();
        if (!SGUtilityText.isValidString(name)) {
            ok = false;
        }
        if (!ok) {
            SGUtility.showMessageDialog(this, INVALID_INPUT_VALUE,
                    SGIConstants.ERROR, JOptionPane.ERROR_MESSAGE);
            return false;
        }
        return super.onOK();
    }

}
