/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGNetCDFDataSetupDialog.java
 *
 * Created on 2009/08/25, 13:05:20
 */

package jp.riken.brain.ni.samuraigraph.data;

import java.util.Map;

import javax.swing.JButton;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfoSet;


/**
 *
 * @author kuromaru
 */
public class SGNetCDFDataSetupDialog extends SGDataSetupDialog implements DocumentListener {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = -874015069620292227L;
    
    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Setup netCDF data";
    
    /**
     * Builds this dialog.
     * 
     * @param owner
     *           the owner of this dialog
     * @param modal
     *           true for modal dialog
     */
    public SGNetCDFDataSetupDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /**
     * Builds this dialog.
     * 
     * @param owner
     *           the owner of this dialog
     * @param modal
     *           true for modal dialog
     */
    public SGNetCDFDataSetupDialog(java.awt.Dialog parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mNetCDFDataSetupPanel = new jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupPanel();
        mButtonPanel = new javax.swing.JPanel();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());
        getContentPane().add(mNetCDFDataSetupPanel, new java.awt.GridBagConstraints());

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 0, 4);
        getContentPane().add(mButtonPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataSetupPanel mNetCDFDataSetupPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    // End of variables declaration//GEN-END:variables

    
    /**
     * Initialize the properties.
     */
    private void initProperty() {
        
        // set the title
        this.setTitle(TITLE);
        
        // add this dialog as an action event listener of the buttons
        this.getOKButton().addActionListener(this);
        this.getCancelButton().addActionListener(this);
        this.mNetCDFDataSetupPanel.getRestoreButton().addActionListener(this);
        this.mNetCDFDataSetupPanel.getClearButton().addActionListener(this);
        this.mNetCDFDataSetupPanel.getComplementButton().addActionListener(this);

        // add this dialog as a property change event listener
        this.mNetCDFDataSetupPanel.getTable().addPropertyChangeListener(this);
        this.mNetCDFDataSetupPanel.getMultipleDimensionStartField().getDocument().addDocumentListener(this);
        this.mNetCDFDataSetupPanel.getMultipleDimensionEndField().getDocument().addDocumentListener(this);
        this.mNetCDFDataSetupPanel.getMultipleDimensionStepField().getDocument().addDocumentListener(this);
        
        this.mNetCDFDataSetupPanel.setPopupDialogOwner(this);
    }

    /**
     * Returns the OK button of this dialog.
     * 
     * @return the OK button
     */
    protected JButton getOKButton() {
        return this.mOKButton;
    }

    /**
     * Returns the Cancel button of this dialog.
     * 
     * @return the Cancel button
     */
    protected JButton getCancelButton() {
        return this.mCancelButton;
    }

    /**
     * Returns an object that has a table to setup data.
     * 
     * @return an object that has a table to setup data
     */
    protected SGIDataSetupTableHolder getTableHolder() {
        return this.mNetCDFDataSetupPanel;
    }
    
    /**
     * Set information of data columns.
     * 
     * @param data
     *            netCDF data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(SGNetCDFData data, 
            SGDataColumnInfoSet colInfoSet,
            Map<String, Object> infoMap, final boolean showDefault) {
        return this.mNetCDFDataSetupPanel.setData(data, colInfoSet, infoMap,
                showDefault);
    }

//    public void setMultipleDimensionPanelVisible(final boolean visible) {
//    	this.mNetCDFDataSetupPanel.setMultipleDimensionPanelVisible(visible);
//    }
    
    public Integer getMultipleDimensionStart() {
    	return this.mNetCDFDataSetupPanel.getMultipleDimensionStart();
    }
    
    public Integer getMultipleDimensionEnd() {
        return this.mNetCDFDataSetupPanel.getMultipleDimensionEnd();
    }
    
//    public void setMultipleDimensionOrigin(final int origin) {
//    	this.mNetCDFDataSetupPanel.setMultipleDimensionOrigin(origin);
//    }
    
    public Integer getMultipleDimensionStep() {
    	return this.mNetCDFDataSetupPanel.getMultipleDimensionStep();
    }

//    public void setMultipleDimensionStep(final int step) {
//    	this.mNetCDFDataSetupPanel.setMultipleDimensionStep(step);
//    }

    /**
     * Called when a text string is inserted.
     */
	public void insertUpdate(DocumentEvent e) {
        SwingUtilities.invokeLater(new InputObserver());
	}

    /**
     * Called when a text string is removed.
     */
	public void removeUpdate(DocumentEvent e) {
        SwingUtilities.invokeLater(new InputObserver());
	}

    /**
     * Called when a text string is changed.
     */
	public void changedUpdate(DocumentEvent e) {
        SwingUtilities.invokeLater(new InputObserver());
	}

}
