/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGNetCDFDataSetupPanel.java
 *
 * Created on 2009/08/17, 16:56:34
 */

package jp.riken.brain.ni.samuraigraph.data;

import java.awt.Component;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Point;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JScrollBar;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

import jp.riken.brain.ni.samuraigraph.base.SGButton;
import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfo;
import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfoSet;
import jp.riken.brain.ni.samuraigraph.base.SGUtilityText;
import ucar.ma2.Array;

/**
 * A panel to setup the properties of netCDF data.
 * 
 */
public class SGNetCDFDataSetupPanel extends javax.swing.JPanel implements
        SGIDataColumnTypeConstants, PropertyChangeListener, ActionListener,
        SGIDataSetupTableHolder {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = -7931773969660601629L;

    /** Creates new form SGNetCDFDataSetupPanel */
    public SGNetCDFDataSetupPanel() {
        super();
        initComponents();
        this.initProperty();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mCoordinateVariableScrollPane = new javax.swing.JScrollPane();
        mCoordinateVariablePanel = new javax.swing.JPanel();
        mDummyPanel = new jp.riken.brain.ni.samuraigraph.data.SGCoordinateVariablePanel();
        mDataColumnSelectionPanel = new jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataColumnSelectionPanel();
        mGlobalAttributeButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mMultipleDimensionPanel = new javax.swing.JPanel();
        mMultiDimensionSubPanel = new javax.swing.JPanel();
        mMultipleDimensionStartLabel = new javax.swing.JLabel();
        mMultipleDimensionEndLabel = new javax.swing.JLabel();
        mMultipleDimensionStepLabel = new javax.swing.JLabel();
        mMultipleDimensionStartField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mMultipleDimensionEndField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mMultipleDimensionStepField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();

        setLayout(new java.awt.GridBagLayout());

        mCoordinateVariableScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Coordinate Variables", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 12))); // NOI18N
        mCoordinateVariableScrollPane.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        mCoordinateVariableScrollPane.setHorizontalScrollBar(null);
        mCoordinateVariableScrollPane.setPreferredSize(new java.awt.Dimension(434, 128));

        mCoordinateVariablePanel.setLayout(new javax.swing.BoxLayout(mCoordinateVariablePanel, javax.swing.BoxLayout.Y_AXIS));
        mCoordinateVariablePanel.add(mDummyPanel);

        mCoordinateVariableScrollPane.setViewportView(mCoordinateVariablePanel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(mCoordinateVariableScrollPane, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(mDataColumnSelectionPanel, gridBagConstraints);

        mGlobalAttributeButton.setText("Show Global Attributes");
        mGlobalAttributeButton.setFont(new java.awt.Font("Dialog", 1, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 4, 4);
        add(mGlobalAttributeButton, gridBagConstraints);

        mMultipleDimensionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Index Selection for Pickup Data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 12))); // NOI18N
        mMultipleDimensionPanel.setLayout(new java.awt.GridBagLayout());

        mMultiDimensionSubPanel.setLayout(new java.awt.GridBagLayout());

        mMultipleDimensionStartLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mMultipleDimensionStartLabel.setText("Start");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(4, 10, 4, 4);
        mMultiDimensionSubPanel.add(mMultipleDimensionStartLabel, gridBagConstraints);

        mMultipleDimensionEndLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mMultipleDimensionEndLabel.setText("End");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mMultiDimensionSubPanel.add(mMultipleDimensionEndLabel, gridBagConstraints);

        mMultipleDimensionStepLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mMultipleDimensionStepLabel.setText("Step");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mMultiDimensionSubPanel.add(mMultipleDimensionStepLabel, gridBagConstraints);

        mMultipleDimensionStartField.setColumns(3);
        mMultipleDimensionStartField.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mMultipleDimensionStartField.setMinimumSize(new java.awt.Dimension(39, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        mMultiDimensionSubPanel.add(mMultipleDimensionStartField, gridBagConstraints);

        mMultipleDimensionEndField.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mMultipleDimensionEndField.setMinimumSize(new java.awt.Dimension(39, 22));
        mMultipleDimensionEndField.setPreferredSize(new java.awt.Dimension(39, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        mMultiDimensionSubPanel.add(mMultipleDimensionEndField, gridBagConstraints);

        mMultipleDimensionStepField.setColumns(3);
        mMultipleDimensionStepField.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mMultipleDimensionStepField.setMinimumSize(new java.awt.Dimension(39, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        mMultiDimensionSubPanel.add(mMultipleDimensionStepField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        mMultipleDimensionPanel.add(mMultiDimensionSubPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(mMultipleDimensionPanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mCoordinateVariablePanel;
    private javax.swing.JScrollPane mCoordinateVariableScrollPane;
    private jp.riken.brain.ni.samuraigraph.data.SGNetCDFDataColumnSelectionPanel mDataColumnSelectionPanel;
    private jp.riken.brain.ni.samuraigraph.data.SGCoordinateVariablePanel mDummyPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mGlobalAttributeButton;
    private javax.swing.JPanel mMultiDimensionSubPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mMultipleDimensionEndField;
    private javax.swing.JLabel mMultipleDimensionEndLabel;
    private javax.swing.JPanel mMultipleDimensionPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mMultipleDimensionStartField;
    private javax.swing.JLabel mMultipleDimensionStartLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mMultipleDimensionStepField;
    private javax.swing.JLabel mMultipleDimensionStepLabel;
    // End of variables declaration//GEN-END:variables

    /**
     * The unit increment of the scroll bar.
     */
    private static final int SCROLL_BAR_UNIT_INCREMENT = 20;
    
    /**
     * The block increment of the scroll bar.
     */
    private static final int SCROLL_BAR_BLOCK_INCREMENT = 4 * SCROLL_BAR_UNIT_INCREMENT;

    /**
     * The netCDF file.
     */
    private SGNetCDFFile mNetCDFFile = null;

    /**
     * The data type.
     */
    private String mDataType = null;
    
    /**
     * The information map.
     * mInfoMap==infoMap
     */
    private Map<String, Object> mInfoMap = null;

    /**
     * Initializes the properties.
     */
    private void initProperty() {
        // set up the scroll bar properties
        JScrollBar vertBar = this.mCoordinateVariableScrollPane.getVerticalScrollBar();
        vertBar.setUnitIncrement(SCROLL_BAR_UNIT_INCREMENT);
        vertBar.setBlockIncrement(SCROLL_BAR_BLOCK_INCREMENT);

        // add an action event listener
        this.getClearButton().addActionListener(this);
        this.getRestoreButton().addActionListener(this);
        this.getComplementButton().addActionListener(this);
        this.mGlobalAttributeButton.addActionListener(this);
        
        // add a property change event listener
        this.getTable().addPropertyChangeListener(this);
        
        this.setMultipleDimensionPanelEnabled(false);
    }
    
    private SGNetCDFDataColumnInfo[] mNetCDFColumns;

    /**
     * Sets the netCDF data.
     * 
     * @param ncFile
     *           the netCDF data
     * @param dataType
     *            type of data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(SGNetCDFFile ncFile, String dataType,
            SGDataColumnInfoSet colInfoSet,
            Map<String, Object> infoMap, final boolean showDefault) {
        
        // check input values
        if (ncFile == null || dataType == null || colInfoSet == null
                || infoMap == null) {
            throw new IllegalArgumentException(
                    "ncFile == null || dataType == null || colInfoSet == null || infoMap == null");
        }
        
        this.mTemporaryColumnInfo.clearColumnInfo();
        
        SGDataColumnInfo[] cols = colInfoSet.getDataColumnInfoArray();
        this.mNetCDFColumns = new SGNetCDFDataColumnInfo[cols.length];
        for (int ii = 0; ii < cols.length; ii++) {
            this.mNetCDFColumns[ii] = (SGNetCDFDataColumnInfo) cols[ii];
        }

        // put the netCDF data into a map
        infoMap.put(KEY_DATA_SOURCE, ncFile);
        
        // clear all
        this.clear();

        // set to the attribute
        this.mNetCDFFile = ncFile;
        this.mDataType = dataType;
        this.mInfoMap = infoMap;
        this.mInfoMap.put(KEY_DATA_TYPE, dataType);
        
        // get variables
        List<SGVariable> varList = ncFile.getVariables();
        
        // setup the table
        if (this.mDataColumnSelectionPanel.setData(dataType, colInfoSet, infoMap,
                showDefault) == false) {
            return false;
        }

        // for SXY type data
        if (SGDataUtility.isSXYTypeData(dataType)) {
            // for multiple dimension
            this.setMultipleDimensionPanelEnabled(false);
            this.mMultipleDimensionPanel.setVisible(true);
        } else {
            // hide the panel
            this.mMultipleDimensionPanel.setVisible(false);
        }

        // add panels of coorinate variables
        for (SGVariable var : varList) {
            if (var.isCoordinateVariable()) {
                final String name = var.getName();
                double[] values = null;
                if (var instanceof SGCoordinateVariable) {
                	SGCoordinateVariable cVar = (SGCoordinateVariable) var;
                	final int len = cVar.getLength();
                	if (len == 0) {
                		// if the length of a coordinate variable is zero, returns false
                		return false;
                	}
                	values = new double[len];
                	for (int ii = 0; ii < len; ii++) {
                		values[ii] = ii;
                	}
                } else {
                    Array array;
                    try {
                        array = var.getVariable().read();
                    } catch (IOException e) {
                        return false;
                    }
                    final int len = (int) array.getSize();
                	if (len == 0) {
                		// if the length of a coordinate variable is zero, returns false
                		return false;
                	}
                    values = new double[len];
                    for (int ii = 0; ii < len; ii++) {
                        values[ii] = array.getDouble(ii);
                    }
                }
                int init = 0;
                for (int ii = 0; ii < this.mNetCDFColumns.length; ii++) {
                    if (name.equals(this.mNetCDFColumns[ii].getVariable().getName())) {
                        init = this.mNetCDFColumns[ii].getOrigin();
                    }
                }
                String unit = var.getUnitsString();
                SGCoordinateVariablePanel p = new SGCoordinateVariablePanel(
                        var, values, init, unit);
                this.mCoordinateVariablePanel.add(p);
            }
        }
        
        // update the components
        this.updateComponentsEnabled();
        
        return true;
    }
    
    private void setMultipleDimensionPanelEnabled(final boolean enabled) {
        this.mMultipleDimensionPanel.setEnabled(enabled);
        this.mMultipleDimensionStartLabel.setEnabled(enabled);
        this.mMultipleDimensionStartField.setEnabled(enabled);
        this.mMultipleDimensionEndLabel.setEnabled(enabled);
        this.mMultipleDimensionEndField.setEnabled(enabled);
        this.mMultipleDimensionStepLabel.setEnabled(enabled);
        this.mMultipleDimensionStepField.setEnabled(enabled);
    }
    
    public boolean setDataToMultipleDimensionPanel(
            Map<String, Object> infoMap, SGNetCDFDataColumnInfo[] nCols, final boolean multiDim) {
        
        if (multiDim) {
            return SGDataUtility.updatePickupParameters(infoMap, nCols);
        }
        
        return true;
    }

    /**
     * Set information of data columns.
     * 
     * @param data
     *            netCDF data
     * @param colInfoSet
     *            data columns
     * @param infoMap
     *            a map of information
     * @param showDefault
     *            a flag whether to show default column type
     * @return true if succeeded
     */
    public boolean setData(SGNetCDFData data, 
            SGDataColumnInfoSet colInfoSet,
            Map<String, Object> infoMap, final boolean showDefault) {

        // set data
        if (this.setData(data.getNetcdfFile(), data.getDataType(), colInfoSet,
        		infoMap, showDefault) == false) {
            return false;
        }

        return true;
    }
    
    /**
     * Returns selected column types.
     * 
     * @return
     *        selected column types
     */
    public SGDataColumnInfo[] getDataColumnTypes() {
    	
        SGDataColumnInfo[] cols = this.mDataColumnSelectionPanel.getDataColumnTypes();
        SGNetCDFDataColumnInfo[] colInfo = new SGNetCDFDataColumnInfo[cols.length];
        for (int ii = 0; ii < cols.length; ii++) {
        	
        	SGNetCDFDataColumnInfo info = (SGNetCDFDataColumnInfo) cols[ii];
        	
            // get values
        	String name = info.getVariable().getName();
            SGVariable var = this.mNetCDFFile.findVariable(name);
            final int origin = this.getCoordinateVariableIndex(name);
            String columnType = cols[ii].getColumnType();
            String valueType = info.getValueType();
            
            // create a new instance
            colInfo[ii] = new SGNetCDFDataColumnInfo(var, var.getNameInPriorityOrder(), valueType, origin);
            colInfo[ii].setColumnType(columnType);
        }
        
        return colInfo;
    }
    
    public SGDataColumnInfoSet getDataColumnInfoSet() {
    	SGDataColumnInfoSet colInfoSet = new SGDataColumnInfoSet(this.getDataColumnTypes());
    	return colInfoSet;
    }

    /**
     * Returns the current value of a coordinate variable.
     * 
     * @param name
     *           the name of a coordinate variable
     * @return
     *           the current value of a given coordinate variable
     */
    public double getCoordinateVariableValue(String name) {
    	SGVariable var = this.mNetCDFFile.findVariable(name);
        if (var == null) {
            return -1;
        }
        if (!var.isCoordinateVariable()) {
            return -1;
        }
        SGCoordinateVariablePanel p = this.getCoordinateVariablePanel(name);
        return p.getCurrentValue();
    }

    /**
     * Returns the current index of a coordinate variable.
     * 
     * @param name
     *           the name of a coordinate variable
     * @return
     *           the current index of a given coordinate variable
     */
    public int getCoordinateVariableIndex(String name) {
    	SGVariable var = this.mNetCDFFile.findVariable(name);
        if (var == null) {
            return -1;
        }
        if (!var.isCoordinateVariable()) {
            return -1;
        }
        SGCoordinateVariablePanel p = this.getCoordinateVariablePanel(name);
        return p.getCurrentIndex();
    }

    /**
     * Sets enabled or disabled the components with selected variables.
     *
     */
    private void updateComponentsEnabled() {
        
        // create a list of the names of selected variables
        SGDataColumnInfo[] cols = this.mDataColumnSelectionPanel.getDataColumnTypes();
        boolean multipleVariable = true;
        List<String> vNameList = new ArrayList<String>();
        for (int ii = 0; ii < cols.length; ii++) {
            SGNetCDFDataColumnInfo info = (SGNetCDFDataColumnInfo) cols[ii];
            String type = info.getColumnType();
            this.mNetCDFColumns[ii].setColumnType(type);
            if (!"".equals(type) && !TIME.equals(type)) {
                vNameList.add(info.getVariableName());
            }
            if (PICKUP.equals(type)) {
                multipleVariable = false;
            }
        }
        
        this.updateColumnTypeForPickup(multipleVariable, cols);
        
        if (multipleVariable) {
            this.setMultipleDimensionPanelEnabled(false);
            this.mInfoMap.put(KEY_MULTIPLE_VARIABLE, Boolean.TRUE);
        } else {
            this.setMultipleDimensionPanelEnabled(true);
            this.mInfoMap.put(KEY_MULTIPLE_VARIABLE, Boolean.FALSE);
            
            this.setDataToMultipleDimensionPanel(this.mInfoMap, this.mNetCDFColumns, true);
            Object start = this.mInfoMap.get(KEY_MULTIPLE_DIMENSION_START);
            this.mMultipleDimensionStartField.setText(start.toString());
            Object end = this.mInfoMap.get(KEY_MULTIPLE_DIMENSION_END);
            this.mMultipleDimensionEndField.setText(end.toString());
            Object step = this.mInfoMap.get(KEY_MULTIPLE_DIMENSION_STEP);
            this.mMultipleDimensionStepField.setText(step.toString());
        }
        
        
        // set enable or disable the components
        Component[] coms = this.mCoordinateVariablePanel.getComponents();
        for (int ii = 0; ii < coms.length; ii++) {
            SGCoordinateVariablePanel p = (SGCoordinateVariablePanel) coms[ii];
            String vName = p.getVariableName();
            final boolean enabled = !vNameList.contains(vName);
            p.setComponentsEnabled(enabled);
        }

        // set enable the button
        this.mGlobalAttributeButton.setEnabled(true);
        
        // set enabled or disabled the complement button
    	SGDataColumnInfoSet colInfoSet = this.getDataColumnInfoSet();
    	SGDataColumnInfo[] colInfoArray = colInfoSet.getDataColumnInfoArray();
    	String[] curColType = new String[colInfoArray.length];
    	for (int ii = 0; ii < curColType.length; ii++) {
    		curColType[ii] = colInfoArray[ii].getColumnType();
    	}
        final boolean b = SGDataUtility.isComplementedButtonEnabled(
        		this.mInfoMap, curColType, 
        		this.mDataColumnSelectionPanel.getColumnInfoList());
        this.getComplementButton().setEnabled(b);
    }
    
    /**
     * Upate column type for exchanging PICKUP column type.
     * <p>
     * For example, if a column type is "Lower Error for height"
     * on variable data Type and take PICKUP,
     * the column type renames to "Lower Error". And reverse.
     * 
     * @param multipleVariable
     * @param cols
     */
    private void updateColumnTypeForPickup(final boolean multipleVariable, final SGDataColumnInfo[] cols) {
        if (this.mTemporaryColumnInfo.multipleVariable!=multipleVariable) {
            final int colIndexColumnType = this.mDataColumnSelectionPanel.getColumnIndex(SGDataColumnSelectionPanel.COLUMN_NAME_COLUMN_TYPE);
            if (multipleVariable) {
                // pickup to variable
                for (int i = 0; i < cols.length; i++) {
                    String coltype = cols[i].getColumnType();
                    String matchedType = "";
                    if (coltype.equals(SGIDataColumnTypeConstants.LOWER_ERROR_VALUE)) {
                        matchedType = SGIDataColumnTypeConstants.LOWER_ERROR_VALUE;
                    } else if (coltype.equals(SGIDataColumnTypeConstants.UPPER_ERROR_VALUE)) {
                        matchedType = SGIDataColumnTypeConstants.UPPER_ERROR_VALUE;
                    } else if (coltype.equals(SGIDataColumnTypeConstants.LOWER_UPPER_ERROR_VALUE)) {
                        matchedType = SGIDataColumnTypeConstants.LOWER_UPPER_ERROR_VALUE;
                    } else if (coltype.equals(SGIDataColumnTypeConstants.TICK_LABEL)) {
                        matchedType = SGIDataColumnTypeConstants.TICK_LABEL;
                    }
                    if (matchedType.equals("")==false) {
                        if (this.mTemporaryColumnInfo.colInfoVariable.length>i) {
                            String type = this.mTemporaryColumnInfo.colInfoVariable[i].getColumnType();
                            if (type.startsWith(matchedType)) {
                                this.mDataColumnSelectionPanel.mTable.setValueAt(type, i, colIndexColumnType);
                                continue;
                            }
                        }
                        this.mDataColumnSelectionPanel.mTable.setValueAt("", i, colIndexColumnType);
                    }
                }
            } else {
                // variable to pickup
                for (int i = 0; i < cols.length; i++) {
                    String coltype = cols[i].getColumnType();
                    if (coltype.startsWith(SGIDataColumnTypeConstants.LOWER_ERROR_VALUE)) {
                        this.mDataColumnSelectionPanel.mTable.setValueAt(
                                SGIDataColumnTypeConstants.LOWER_ERROR_VALUE,
                                i, colIndexColumnType);
                    } else if (coltype.startsWith(SGIDataColumnTypeConstants.UPPER_ERROR_VALUE)) {
                        this.mDataColumnSelectionPanel.mTable.setValueAt(
                                SGIDataColumnTypeConstants.UPPER_ERROR_VALUE,
                                i, colIndexColumnType);
                    } else if (coltype.startsWith(SGIDataColumnTypeConstants.LOWER_UPPER_ERROR_VALUE)) {
                        this.mDataColumnSelectionPanel.mTable.setValueAt(
                                SGIDataColumnTypeConstants.LOWER_UPPER_ERROR_VALUE,
                                i, colIndexColumnType);
                    } else if (coltype.startsWith(SGIDataColumnTypeConstants.TICK_LABEL)) {
                        this.mDataColumnSelectionPanel.mTable.setValueAt(
                                SGIDataColumnTypeConstants.TICK_LABEL,
                                i, colIndexColumnType);
                    }
                }
            }
        }
        this.mTemporaryColumnInfo.setColumnInfo(multipleVariable, cols);
    }
    
    private static class TemporaryColumnInfo {
        boolean multipleVariable;
        SGDataColumnInfo[] colInfoVariable;
        SGDataColumnInfo[] colInfoPickup;
        void setColumnInfo(final boolean multipleVariable, final SGDataColumnInfo[] cols) {
            this.multipleVariable = multipleVariable;
            if (multipleVariable) {
                this.colInfoVariable = new SGDataColumnInfo[cols.length];
                for (int i = 0; i < cols.length; i++) {
                    this.colInfoVariable[i] = (SGDataColumnInfo)cols[i].clone();
                }
            } else {
                this.colInfoPickup = new SGDataColumnInfo[cols.length];
                for (int i = 0; i < cols.length; i++) {
                    this.colInfoPickup[i] = (SGDataColumnInfo)cols[i].clone();
                }
            }
        }
        void clearColumnInfo() {
            this.colInfoVariable = new SGDataColumnInfo[0];
            this.colInfoPickup = new SGDataColumnInfo[0];
        }
    }
    
    private final TemporaryColumnInfo mTemporaryColumnInfo = new TemporaryColumnInfo();

    /**
     * Returns the panel object for a coordinate variable.
     * 
     * @param name
     *           the name of a coordinate variable
     * @return the panel object for a given coordinate variable
     */
    private SGCoordinateVariablePanel getCoordinateVariablePanel(String name) {
        Component[] coms = this.mCoordinateVariablePanel.getComponents();
        for (int ii = 0; ii < coms.length; ii++) {
            SGCoordinateVariablePanel p = (SGCoordinateVariablePanel) coms[ii];
            String cName = p.getVariableName();
            if (name.equals(cName)) {
                return p;
            }
        }
        return null;
    }
    
    /**
     * Returns the button to restore all data column types.
     * 
     * @return the button to restore all data column types
     */
    public SGButton getRestoreButton() {
        return this.mDataColumnSelectionPanel.getRestoreButton();
    }

    /**
     * Returns the button to clear all data column types.
     * 
     * @return the button to clear all data column types
     */
    public SGButton getClearButton() {
        return this.mDataColumnSelectionPanel.getClearButton();
    }
    
    /**
     * Returns the button to complement the column types.
     * 
     * @return the button to complement the column types
     */
    public SGButton getComplementButton() {
        return this.mDataColumnSelectionPanel.getComplementButton();
    }

    /**
     * Returns the table.
     * @return
     *         a table object
     */
    public JTable getTable() {
        return this.mDataColumnSelectionPanel.getTable();
    }

    /**
     * Checks selected items.
     * @return
     *         true if selected items are valid for the data type
     */
    public boolean checkSelectedItems() {
        
        // check selected items of the table
        if (this.mDataColumnSelectionPanel.checkSelectedItems() == false) {
            return false;
        }

        // check netCDF data
        SGDataColumnInfo[] cols = this.mDataColumnSelectionPanel.getDataColumnTypes();
        SGNetCDFDataColumnInfo[] colsNetCDF = new SGNetCDFDataColumnInfo[cols.length];
        for (int ii = 0; ii < cols.length; ii++) {
        	colsNetCDF[ii] = (SGNetCDFDataColumnInfo) cols[ii];
        }
        Map<String, Object> infoMap = new HashMap<String, Object>(this.mInfoMap);
        infoMap.put(KEY_MULTIPLE_DIMENSION_START, this.getMultipleDimensionStart());
        infoMap.put(KEY_MULTIPLE_DIMENSION_END, this.getMultipleDimensionEnd());
        infoMap.put(KEY_MULTIPLE_DIMENSION_STEP, this.getMultipleDimensionStep());
        if (SGDataUtility.checkNetCDFDataColumns(colsNetCDF, this.mDataType, 
        		this.mNetCDFFile, infoMap) == false) {
            return false;
        }

        return true;
    }
    
//    private List<String> getXNameList() {
//        return this.getColumnNameList(X_VALUE);
//    }
//    private List<String> getYNameList() {
//        return this.getColumnNameList(Y_VALUE);
//    }
//    
//    private List<String> getColumnNameList(final String colType) {
//        List<String> list = new ArrayList<String>();
//        SGDataColumnInfo[] cols = this.mDataColumnSelectionPanel.getDataColumnTypes();
//        for (int ii = 0; ii < cols.length; ii++) {
//            if (colType.equals(cols[ii].getColumnType())) {
//                list.add(cols[ii].getTitle());
//            }
//        }
//        return list;
//    }
    
    /**
     * Update the table.
     */
    public void updateTable() {
        this.mDataColumnSelectionPanel.updateTable();
    }

    /**
     * Clear all data.
     */
    public void clear() {
        this.mCoordinateVariablePanel.removeAll();
        this.mDataColumnSelectionPanel.clear();
        this.mGlobalAttributeButton.setEnabled(false);
        if (this.mGlobalAttributeDialog != null) {
            this.mGlobalAttributeDialog.setVisible(false);
        }
    }

    /**
     * Called when the table is changed.
     * 
     * @param evt
     *            an event that the property changes
     */
    public void propertyChange(PropertyChangeEvent evt) {
        Object source = evt.getSource();
        if (source.equals(this.getTable())) {
            String name = evt.getPropertyName();
            if ("tableCellEditor".equals(name)) {
                SwingUtilities.invokeLater(new Runnable(){
                    public void run() {
                        updateComponentsEnabled();
                    }
                });
            }
        }
    }

    /**
     * Called when an action event is generated.
     * @param e
     *         an action event
     */
    public void actionPerformed(ActionEvent e) {
        Object source = e.getSource();
        if (source.equals(this.getClearButton()) || source.equals(this.getRestoreButton())
        		|| source.equals(this.getComplementButton())) {
            SwingUtilities.invokeLater(new Runnable(){
                public void run() {
                    updateComponentsEnabled();
                }
            });
        } else if (source.equals(this.mGlobalAttributeButton)) {
            
            // if the dialog is already displayed, do nothing
            if (this.mGlobalAttributeDialog != null && this.mGlobalAttributeDialog.isVisible()) {
                return;
            }
            
            SGGlobalAttributeDialog dg = null;
            if (this.mDialogOwner instanceof Dialog) {
                dg = new SGGlobalAttributeDialog((Dialog) this.mDialogOwner, false);
            } else if (this.mDialogOwner instanceof Frame) {
                dg = new SGGlobalAttributeDialog((Frame) this.mDialogOwner, false);
            } else {
            	throw new Error("Not supported dialog owner.");
            }
            this.mGlobalAttributeDialog = dg;
            
            dg.setNetcdfFile(this.mNetCDFFile);
//            Point pos = this.mGlobalAttributeButton.getLocationOnScreen();
            Point pos = this.mDialogOwner.getLocation();
            dg.setLocation(pos.x + 20, pos.y + 20);
            dg.setVisible(true);
        }
    }
    
    /**
     * The dialog to show global attributes.
     */
    private SGGlobalAttributeDialog mGlobalAttributeDialog = null;

    /**
     * Sets the data type.
     * @param dataType
     *                the data type to be set
     */
    public void setDataType(String dataType) {
        this.mDataType = dataType;
        this.mDataColumnSelectionPanel.setDataType(dataType);
    }
    
    /**
     * The owner of popup dialogs.
     */
    private Window mDialogOwner = null;

    /**
     * Sets the owner of popup dialogs.
     * 
     * @param owner
     *           the owner of popup dialogs
     */
    public void setPopupDialogOwner(Window owner) {
        this.mDialogOwner = owner;
        this.mDataColumnSelectionPanel.setPopupDialogOwner(owner);
    }
    
    public JTextField getMultipleDimensionStartField() {
    	return this.mMultipleDimensionStartField;
    }
    
    public Integer getMultipleDimensionStart() {
        String str = this.mMultipleDimensionStartField.getText();
        if (str == null) {
            return null;
        }
        Integer offset = SGUtilityText.getInteger(str);
        return offset;
    }
    
    public JTextField getMultipleDimensionEndField() {
        return this.mMultipleDimensionEndField;
    }
    
    public Integer getMultipleDimensionEnd() {
        String str = this.mMultipleDimensionEndField.getText();
        if (str == null) {
            return null;
        }
        Integer offset = SGUtilityText.getInteger(str);
        return offset;
    }

    public JTextField getMultipleDimensionStepField() {
    	return this.mMultipleDimensionStepField;
    }

    public Integer getMultipleDimensionStep() {
        String str = this.mMultipleDimensionStepField.getText();
        if (str == null) {
            return null;
        }
        Integer offset = SGUtilityText.getInteger(str);
        return offset;
    }
    
    public Boolean isVariableDataType() {
        for (int ii = 0; ii < this.mNetCDFColumns.length; ii++) {
            if (PICKUP.equals(this.mNetCDFColumns[ii].getColumnType())) {
                return Boolean.FALSE;
            }
        }
        return Boolean.TRUE;
    }

}
