package jp.riken.brain.ni.samuraigraph.figure.java2d;

import jp.riken.brain.ni.samuraigraph.base.SGTuple2f;
import jp.riken.brain.ni.samuraigraph.figure.*;

/**
 * A group of drawing elements for scalar-type XY data.
 * 
 */
public abstract class SGElementGroupSXY extends SGElementGroup {

    /**
     * The default constructor.
     * 
     */
    public SGElementGroupSXY() {
        super();
    }

    /**
     * Initializes the drawing elements with given coordinates.
     * 
     * @param array
     *           an array of coordinates
     * @return true if succeeded
     */
    protected abstract boolean initDrawingElement(final SGTuple2f[] array);

    /**
     * Sets the location of the drawing elements.
     * 
     * @param pointArray
     *           an array of coordinates
     * @return true if succeeded
     */
    public abstract boolean setLocation(final SGTuple2f[] pointArray);

}
