/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SGPropertyDialogSXYZData.java
 *
 * Created on 2009/10/20, 11:10:25
 */

package jp.riken.brain.ni.samuraigraph.figure.java2d;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JSpinner;
import javax.swing.JTextField;

import jp.riken.brain.ni.samuraigraph.base.SGData;
import jp.riken.brain.ni.samuraigraph.base.SGDataColumnInfo;
import jp.riken.brain.ni.samuraigraph.base.SGIPropertyDialogObserver;
import jp.riken.brain.ni.samuraigraph.data.SGDataSetupDialog;
import jp.riken.brain.ni.samuraigraph.data.SGDataUtility;
import jp.riken.brain.ni.samuraigraph.data.SGIDataColumnTypeConstants;
import jp.riken.brain.ni.samuraigraph.data.SGNetCDFData;

/**
 *
 * @author kuromaru
 */
public class SGPropertyDialogSXYZData extends SGDataDialog implements SGIDataColumnTypeConstants {

    /**
     * Serial Version UID
     */
    private static final long serialVersionUID = 4413621536454191591L;
    
    /**
     * The title of this dialog.
     */
    public static final String TITLE = "Data Properties";

    /** Creates new form SGPropertyDialogSXYZData */
    public SGPropertyDialogSXYZData(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.initProperty();
        this.initialize();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mCommonPanel = new javax.swing.JPanel();
        mLegendVisibleCheckBox = new jp.riken.brain.ni.samuraigraph.base.SGCheckBox();
        mNameLabel = new javax.swing.JLabel();
        mNameField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mAxisPanel = new jp.riken.brain.ni.samuraigraph.base.SGTwoAxesSelectionPanel();
        mDataColumnSelectionButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mColorMapPanel = new javax.swing.JPanel();
        mWidthValueLabel = new javax.swing.JLabel();
        mWidthValueTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mHeightValueLabel = new javax.swing.JLabel();
        mHeightValueTextField = new jp.riken.brain.ni.samuraigraph.base.SGTextField();
        mSizeLabel = new javax.swing.JLabel();
        mSizeSeparator = new javax.swing.JSeparator();
        mButtonPanel = new javax.swing.JPanel();
        mOKButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mCancelButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();
        mPreviewButton = new jp.riken.brain.ni.samuraigraph.base.SGButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        mCommonPanel.setLayout(new java.awt.GridBagLayout());

        mLegendVisibleCheckBox.setText("Legend Visible");
        mLegendVisibleCheckBox.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        mCommonPanel.add(mLegendVisibleCheckBox, gridBagConstraints);

        mNameLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        mNameLabel.setText("Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 0);
        mCommonPanel.add(mNameLabel, gridBagConstraints);

        mNameField.setColumns(16);
        mNameField.setFont(new java.awt.Font("Dialog", 0, 12));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 0);
        mCommonPanel.add(mNameField, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        mCommonPanel.add(mAxisPanel, gridBagConstraints);

        mDataColumnSelectionButton.setText("Data Column");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        mCommonPanel.add(mDataColumnSelectionButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
        getContentPane().add(mCommonPanel, gridBagConstraints);

        mColorMapPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        mColorMapPanel.setPreferredSize(new java.awt.Dimension(300, 200));
        mColorMapPanel.setLayout(new java.awt.GridBagLayout());

        mWidthValueLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mWidthValueLabel.setText("Width");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 5);
        mColorMapPanel.add(mWidthValueLabel, gridBagConstraints);

        mWidthValueTextField.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        mWidthValueTextField.setText("0.0");
        mWidthValueTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mWidthValueTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 20);
        mColorMapPanel.add(mWidthValueTextField, gridBagConstraints);

        mHeightValueLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        mHeightValueLabel.setText("Height");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        mColorMapPanel.add(mHeightValueLabel, gridBagConstraints);

        mHeightValueTextField.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        mHeightValueTextField.setText("0.0");
        mHeightValueTextField.setFont(new java.awt.Font("Dialog", 0, 12));
        mHeightValueTextField.setPreferredSize(new java.awt.Dimension(70, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 20);
        mColorMapPanel.add(mHeightValueTextField, gridBagConstraints);

        mSizeLabel.setFont(new java.awt.Font("Dialog", 3, 12)); // NOI18N
        mSizeLabel.setText("Size");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 10);
        mColorMapPanel.add(mSizeLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 40, 5, 0);
        mColorMapPanel.add(mSizeSeparator, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(mColorMapPanel, gridBagConstraints);

        mOKButton.setText("OK");
        mOKButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mOKButton);

        mCancelButton.setText("Cancel");
        mCancelButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mCancelButton);

        mPreviewButton.setText("Preview");
        mPreviewButton.setFont(new java.awt.Font("Dialog", 1, 12));
        mButtonPanel.add(mPreviewButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(mButtonPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private jp.riken.brain.ni.samuraigraph.base.SGTwoAxesSelectionPanel mAxisPanel;
    private javax.swing.JPanel mButtonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mCancelButton;
    private javax.swing.JPanel mColorMapPanel;
    private javax.swing.JPanel mCommonPanel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mDataColumnSelectionButton;
    private javax.swing.JLabel mHeightValueLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mHeightValueTextField;
    private jp.riken.brain.ni.samuraigraph.base.SGCheckBox mLegendVisibleCheckBox;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mNameField;
    private javax.swing.JLabel mNameLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mOKButton;
    private jp.riken.brain.ni.samuraigraph.base.SGButton mPreviewButton;
    private javax.swing.JLabel mSizeLabel;
    private javax.swing.JSeparator mSizeSeparator;
    private javax.swing.JLabel mWidthValueLabel;
    private jp.riken.brain.ni.samuraigraph.base.SGTextField mWidthValueTextField;
    // End of variables declaration//GEN-END:variables

    /**
     * Initialize the properties.
     *
     */
    private void initProperty() {
        
        // set the title
        this.setTitle(SGPropertyDialogSXYZData.TITLE);

        // add an action event listener
        this.mDataColumnSelectionButton.addActionListener(this);
        this.mAxisPanel.addActionListener(this);
        this.mLegendVisibleCheckBox.addActionListener(this);

        // set the name
        this.mNameField.setDescription("Name");
        this.mWidthValueTextField.setDescription("Width");
        this.mHeightValueTextField.setDescription("Height");
    }

    public List getColorSelectionButtonsList() {
        return new ArrayList();
    }

    public List getTextFieldComponentsList() {
        final List list = this.getFormattedTextFieldsListFromSpinners();
        list.addAll(this.getNumberTextFieldList());
        list.add(this.mNameField);
        return list;
    }

    public List getNumberTextFieldList() {
        final List<JTextField> list = new ArrayList<JTextField>();
        list.add(this.mWidthValueTextField);
        list.add(this.mHeightValueTextField);
        return list;
    }

    public List getSpinnerList() {
        return new ArrayList<JSpinner>();
    }

    protected JButton getOKButton() {
        return this.mOKButton;
    }

    protected JButton getCancelButton() {
        return this.mCancelButton;
    }

    protected JButton getPreviewButton() {
        return this.mPreviewButton;
    }

    public boolean setDialogProperty() {
        List list = this.mPropertyDialogObserverList;
        final int len = list.size();

        // column selection button
        final boolean single = (len == 1);
        this.mDataColumnSelectionButton.setEnabled(single);

        if (this.mAxisPanel.setSelected(list) == false) {
            return false;
        }

        // data name
        String name = this.getDataNameFromObservers();
        this.mNameField.setText(name);

        // visible in legend
        Boolean legendVisible = this.getLegendVisibleFromObservers();
        this.mLegendVisibleCheckBox.setSelected(legendVisible);
        
        SGISXYZDataDialogObserver obs0 = (SGISXYZDataDialogObserver) list.get(0);
        
        final double widthValue0 = obs0.getRectangleWidthValue();
        final double heightValue0 = obs0.getRectangleHeightValue();
        
        Double widthValue = Double.valueOf(widthValue0);
        Double heightValue = Double.valueOf(heightValue0);

        if (list.size() > 1) {
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYZDataDialogObserver obs1 = (SGISXYZDataDialogObserver) list
                        .get(ii);
                final double widthValue1 = obs1.getRectangleWidthValue();
                if (widthValue0 != widthValue1) {
                    widthValue = null;
                    break;
                }
            }
            for (int ii = 1; ii < list.size(); ii++) {
                SGISXYZDataDialogObserver obs1 = (SGISXYZDataDialogObserver) list
                        .get(ii);
                final double heightValue1 = obs1.getRectangleHeightValue();
                if (heightValue0 != heightValue1) {
                    heightValue = null;
                    break;
                }
            }
        }

        // set values to the components
        this.setValue(this.mWidthValueTextField, widthValue);
        this.setValue(this.mHeightValueTextField, heightValue);

        // update the components
        this.updateComponents();

        return true;
    }
    
    // Set enabled or disabled the components depending on the data type.
    private void updateComponents() {
        List list = this.mPropertyDialogObserverList;

        boolean enabled = true;
        for (int ii = 0; ii < list.size(); ii++) {
            SGISXYZDataDialogObserver obs = (SGISXYZDataDialogObserver) list.get(ii);
            SGData data = obs.getData();
            if (SGDataUtility.isArrayData(data)) {
                enabled = true;
            } else if (SGDataUtility.isNetCDFData(data)) {
            	if (this.mDataInfoArray != null) {
            		boolean indexContains = false;
//            		for (int jj = 0; jj < this.mDataInfoArray.length; jj++) {
//            			if (INDEX.equals(this.mDataInfoArray[jj].getColumnType())) {
//            				indexContains = true;
//            				break;
//            			}
//            		}
            		if (!indexContains) {
            			enabled = false;
            		}
                    if (enabled == false) {
                    	break;
                    }
            	} else {
            		SGNetCDFData nData = (SGNetCDFData) data;
            		enabled = nData.isSerialNumberAvailable();
            	}
            } else {
                throw new Error("Unsupported data type: " + data.getDataType());
            }
            if (!enabled) {
            	break;
            }
        }
        
        this.mSizeLabel.setEnabled(enabled);
        this.mSizeSeparator.setEnabled(enabled);
    	this.mWidthValueLabel.setEnabled(enabled);
    	this.mWidthValueTextField.setEnabled(enabled);
    	this.mHeightValueLabel.setEnabled(enabled);
    	this.mHeightValueTextField.setEnabled(enabled);
    }
    
    public static final String ERRMSG_WIDTH_VALUE_INVALID = "Width value is invalid.";
    
    public static final String ERRMSG_HEIGHT_VALUE_INVALID = "Width value is invalid.";

    public boolean setPropertiesToListeners(SGIPropertyDialogObserver l) {
        SGISXYZDataDialogObserver obs = (SGISXYZDataDialogObserver) l;
        
        // set data columns
        if (this.mDataInfoArray != null) {
            SGIDataPropertyDialogObserver obs0 = (SGIDataPropertyDialogObserver) this.mPropertyDialogObserverList
                    .get(0);
            if (obs0.setColumnInfo(this.mDataInfoArray, this.mCommitActionStateMessage) == false) {
            	return false;
            }
        }

        // get values
        final int xConfig = this.mAxisPanel.getXAxisLocation();
        final int yConfig = this.mAxisPanel.getYAxisLocation();
        final Number widthValue = this.getNumber(this.mWidthValueTextField);
        final Number heightValue = this.getNumber(this.mHeightValueTextField);

        if (obs.hasValidRectangleWidthValue(xConfig, widthValue) == false) {
            this.setInputErrorMessage(ERRMSG_WIDTH_VALUE_INVALID);
            return false;
        }
        if (obs.hasValidRectangleWidthValue(yConfig, heightValue) == false) {
            this.setInputErrorMessage(ERRMSG_HEIGHT_VALUE_INVALID);
            return false;
        }

        // set the related axes
        if (xConfig != -1) {
            obs.setXAxisLocation(xConfig);
        }

        if (yConfig != -1) {
            obs.setYAxisLocation(yConfig);
        }

        // data name
        String name = this.mNameField.getText();
        if (name != null) {
            obs.setName(name);
        }

        // visibility in legend
        Boolean legendVisible = this.mLegendVisibleCheckBox.getSelected();
        if (legendVisible != null) {
            obs.setVisibleInLegend(legendVisible.booleanValue());
        }

        // width
        if (widthValue != null) {
            obs.setRectangleWidthValue(widthValue.doubleValue());
        }

        // height
        if (heightValue != null) {
            obs.setRectangleHeightValue(heightValue.doubleValue());
        }

        return true;
    }

    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        Object source = e.getSource();
        String command = e.getActionCommand();
        if (source.equals(this.mDataColumnSelectionButton)) {
            this.showDataColumnSelectionDialog();
        } else if (source.equals(this.mDataColumnSelectionDialog)) {
            SGDataSetupDialog dg = (SGDataSetupDialog) source;
            if (OK_BUTTON_TEXT.equals(command)) {
            	SGDataColumnInfo[] colInfo = dg.getDataColumnInfoSet().getDataColumnInfoArray();
                this.mDataInfoArray = colInfo;
                
                // update components
                this.updateComponents();
            }
        }
    }

    /**
     * Overrode this method to check the input values.
     * 
     * @return true if all input values are valid
     */
    protected boolean hasValidInputValues() {
        boolean valid = true;
        if (super.hasValidInputValues() == false) {
            valid = false;
        }
        
        // check the data name
        if (this.mNameField.hasValidText() == false) {
            this.addInputErrorDescription(this.mNameField.getDescription());
            valid = false;
        }

        if (this.mColorMapPanel.isVisible()) {
            if (this.hasValidNumber(this.mWidthValueTextField, Float.MIN_VALUE, null) == false) {
            	valid = false;
            }
            if (this.hasValidNumber(this.mHeightValueTextField, Float.MIN_VALUE, null) == false) {
            	valid = false;
            }
        }
    	return valid;
    }

}
